function [QQ]=derivative(func,psi,par,varargin)
t1=clock;
tol=.1e-7;
%
yb=feval(func,psi,par,varargin{:});

[a,b]=size(yb);
iend=length(psi);
if b ~= 1
 disp(' fatal (deriv) function should be column-vector valued')
 yb
 disp(' press any key to continue ...')
 pause
 return
end

%
QQ   = zeros(a,iend);
der  = zeros(a,iend);
pert = zeros(iend,1);
psid = zeros(iend,1);
%
%iend=8;
%sprintf(' Entering DERIV, must go through %g steps',iend)
for ii=1:iend
    %sprintf(' step %g\n',ii)
    psid=psi;
    if abs(psi(ii)) > .1e-15
        pert(ii)=tol*psi(ii);
        psid(ii)=psid(ii) + pert(ii);
    else
        pert(ii)=tol;
        psid(ii)=psid(ii) + pert(ii);
    end
    y=feval(func,psid,par,varargin{:});
    der(:,ii)=(y-yb);
end

for ii = 1:iend
QQ(:,ii)=der(:,ii)/pert(ii);
end
t2=clock;
fprintf('%g seconds used to linearize function\n' ...
  ,etime(t2,t1))