%-------------------------------------------------------------------------
%-------------------------------------------------------------------------
%Specify in this file the values of conditional variables and/or conterfactual innovations
%It applies only to the case conditional=2 and conditional=3 (recall that conditional is set in forecastkalman1)
%This file is loaded up in forecastkalman1
%-------------------------------------------------------------------------

innovation_counter = zeros(size(D,2),LL); %do not modify this


%-------------------------------------------------------------------------
%   SET VALUES OF INNOVATIONS                  
%-------------------------------------------------------------------------
innov_counter=0; %innov_counter=1, if you want to set counterfactual values for innovations; =0 otherwise 

if innov_counter ==1
    %the first term on the rhs below is needed to zero out the existing innovations you select and the second term is to replace it with counterfactual values you provide
    %innovation_counter(8,1) = err(8,find(date==2008.0))-0.0033; %  - 2*err(9,find(date==2006.0):find(date==2006.75));
 % innovation_counter(12,:) = -err(12,find(date==2008.0):find(date==2009.75))  +[0.01 0 -0.02 -0.04 -0.04 -0.04 -.04 0]; %[0.2*err(12,find(date==1998.75))*ones(1,1) 0.5*err(12,find(date==1998.75))*ones(1,3) 0.45*err(12,find(date==1998.75))*ones(1,4)];
    %innovation_counter(9,:) = -err(9,find(date==2008.0):find(date==2009.75))  +10*[0.2*err(9,find(date==2001.25))*ones(1,3) 0.4*err(9,find(date==2002.25))*ones(1,2) -0.1*err(9,find(date==2002.25))*ones(1,3)];    
    %innovation_counter(11,:) = [0 0 0 -0.5 -0.5 -0.2 -0.2 -0.2 -0.2 -0.2];%[0 0 0 0 0 0 -0.3 -0.5 -0.6 -0.5];
    %innovation_counter(5,:) =
    %-err(5,find(date==2007.5):find(date==2009.75)) + [-0.0255 -.01881 -.006677 0.0069 -.00083 0.0074 -.00064 0.011 0.0046 0.0133 ] ;
end
%-------------------------------------------------------------------------



%-------------------------------------------------------------------------
% SET ybar AND SPECIFIES WHICH VARIABLES AND INNOVATIONS YOU WANT TO USE
%-------------------------------------------------------------------------
%ybar is a matrix containing the values of constrained variables. Dimension: nnxLLL, where nn is the No. of constrained variables. LLL can be =<LL

ybar =  [%Y(find(tauvar==14),t1+1:end)];  %Re --ECB Projections
         %mean(Y(find(tauvar==11),find(date==2005.25):find(date==2006.25)))*ones(1,LL);
         %mean(Y(find(tauvar==9),find(date==2006.0):find(date==2006.75))+Y(find(tauvar==2),find(date==2006.0):find(date==2006.75)) )*ones(1,LL);
         %-0.003722153123438*ones(1,LL)];
         %[Y(find(tauvar==5),t1+1:t1+6) Y(find(tauvar==5),t1+7:t1+LL)-0.0005];
         %Y(find(tauvar==1),t1+1:end)+Y(find(tauvar==2),t1+1:end)] 
         %Y(find(tauvar==9),t1+1:end)+Y(find(tauvar==2),t1+1:end)];
      Y(find(tauvar==18),t1+1:end)];
      %[-0.1642, Y(find(tauvar==1),t1+2:end)+Y(find(tauvar==2),t1+2:end)]]; % stock market
         %(Y(find(tauvar==4),end)+Y(find(tauvar==2),end))*ones(1,8)]; %nominal credit
         

%Y(find(tauvar==14),t1+1:end);
%ones(1,LL)*0.008*1.3; %Constant DM1
%Y(find(tauvar==9),t1+1:end); %DM3  --BVAR + ECB Projections

aa = [18 ]; %[14 18  23 ]; %location of the variables you want to constrain, e.g. aa=[5 14], whose value is defined in ybar. numbering refers to location in full set of observables, not in tauvar
%21: nominal M1 growth, 22: nominal M3 growth; 23= nominal net-worth; growth; 24= nominal oil price growth; 25: nominal credit growth;

bb = { %6,  1, 0;
       %17,  0, 1;
       %19,  1, 0};
       24, 1, 0};  %1st column: # of the shock (in full list, not in taushock); 2nd column: patriot; 3rd column is signal; if shock does NOT have signal, 2nd column=1 and 3rd column 0

   
%financial scenario
aa = [11 14 23 25];

bb = {%6,  1, 0;
      %9,  1, 0;
      17, 1, 1;
      19, 1, 0;
      21, 1, 0};
  
YY_baseline = H*xsmooth + repmat(alf(tauvar'),1,size(xsmooth,2)) ; %we do that because for some variables, such as the stock market, the m.e. is not negligible. So, we want to use the "fitted" path rather than the data itself as the baseline

ybar =  [Y(find(tauvar==11),t1+1:end)+ 0.0015; %this amounts to 60 bp rise in premium
         Y(find(tauvar==14),t1+1:end);  %Re
         %Y(find(tauvar==8),t1+1:end)+Y(find(tauvar==2),t1+1:end); %M1
         %Y(find(tauvar==9),t1+1:end)+Y(find(tauvar==2),t1+1:end); %M3
         [-0.107*0.75 YY_baseline(find(tauvar==1),t1+2:end)+Y(find(tauvar==2),t1+2:end)]; %-0.107*0.81%stock market
         %[YY_baseline(find(tauvar==4),t1+1:end)+Y(find(tauvar==2),t1+1:end)]];  %[-0.0065 YY_baseline(find(tauvar==4),t1+2:end)+Y(find(tauvar==2),t1+2:end)]];
         [(YY_baseline(find(tauvar==4),t1+1:t1+6)+Y(find(tauvar==2),t1+1:t1+6)-repmat(0.0083,1,6))  YY_baseline(find(tauvar==4),t1+7:end)+Y(find(tauvar==2),t1+7:end)]];

%computing premium equivalent of credit restriction
% aa = [14 23 25]; %23
% 
% bb = {19, 1,  0;
%       %17, 1, 1};
%       21, 0,  0};
%   
% YY_baseline = H*xsmooth + repmat(alf(tauvar'),1,size(xsmooth,2)) ; %we do that because for some variables, such as the stock market, the m.e. is not negligible. So, we want to use the "fitted" path rather than the data itself as the baseline
% 
% ybar =  [Y(find(tauvar==14),t1+1:end);  %Re
%       %[Y(find(tauvar==1),t1+1:t1+6) YY_baseline(find(tauvar==1),t1+7:end)]+Y(find(tauvar==2),t1+1:end) - [0.00 0.00822 0.00982 0.01285 0.01852 0.02798 -0.00 -0.00 -0.00 -0.00]; %[0.01966 0.01966 0.0229 0.0287 0.0383 0.0534 0.0 0.0 0.0 0.0];
%       %[(YY_baseline(find(tauvar==4),t1+1:t1+6)+Y(find(tauvar==2),t1+1:t1+6)-repmat(0.0067,1,6))  YY_baseline(find(tauvar==4),t1+7)+Y(find(tauvar==2),t1+7)-0.0067*0.75  YY_baseline(find(tauvar==4),t1+8)+Y(find(tauvar==2),t1+8)-0.0067*0.5 YY_baseline(find(tauvar==4),t1+9)+Y(find(tauvar==2),t1+9)-0.0067*0.25  YY_baseline(find(tauvar==4),t1+10)+Y(find(tauvar==2),t1+10)]];
%          [Y(find(tauvar==1),t1+1:t1+6) YY_baseline(find(tauvar==1),t1+7:end)]+Y(find(tauvar==2),t1+1:end) - [0.00 0.008973 0.01001 0.01226 0.01686 0.0248 0.01 -0.015 -0.025 -0.02]; %[0.01 0.01525 0.0166 0.01950 0.02508 -0.01 -0.005 -0.01 -0.03 -0.02]; %[0.01966 0.01966 0.0229 0.0287 0.0383 0.0534 0.0 0.0 0.0 0.0];
%          [(YY_baseline(find(tauvar==4),t1+1:t1+6)+Y(find(tauvar==2),t1+1:t1+6)-repmat(0.0083,1,6))  YY_baseline(find(tauvar==4),t1+7:end)+Y(find(tauvar==2),t1+7:end)]];


%when you want to condition on MPE external assumptions activate the following few lines
% aa=[12 14 23 24]; 
% bb= {17, 1, 1;
%      19, 1, 0;
%      %21, 1, 1; %%%
%      24, 1, 0;
%      25, 1, 0};
% ybar = [Y(find(tauvar==12),t1+1:end); Y(find(tauvar==14),t1+1:end); 1*(Y(find(tauvar==1),t1+1:end)+Y(find(tauvar==2),t1+1:end));  Y(find(tauvar==18),t1+1:end)+Y(find(tauvar==2),t1+1:end)];


%-------unchanged rate
% ybar =  [Y(find(tauvar==14),t1+1:end);  %Re --MPE
%          mean(Y(find(tauvar==9),t1-5:t1-2)+Y(find(tauvar==2),t1-5:t1-2))*ones(1,LL)];
% aa = [14 22]; 
% bb = { 9, 1, 0;
%       19, 1, 0};  
%------       


%------high M3 and Credit growth, with policy rate, stock market and premium at baseline
% innovation_counter = zeros(size(D,2),LL);
% ybar= [Y(find(tauvar==11),t1+1:end);
%        Y(find(tauvar==14),t1+1:end); 
%        repmat(Y(find(tauvar==9),t1)+Y(find(tauvar==2),t1),1,10); %M3
%        YY_baseline(find(tauvar==1),t1+1:end)+Y(find(tauvar==2),t1+1:end);
%        repmat(YY_baseline(find(tauvar==4),t1)+Y(find(tauvar==2),t1),1,10)];
% 
% aa = [11 14 22 23 25]; 
% bb = { 9, 1, 0;
%       17, 1, 1;
%       19, 1, 0;
%        21, 1, 0};  
%--------
       




