%-------------------------------------------------------------------------
%-------------------------------------------------------------------------
%Specify in this file the values of conditional variables and/or conterfactual innovations
%It applies only to the case conditional=2 and conditional=3,4,5 (recall that conditional is set in forecastkalman1)
%This file is loaded up in forecastkalman1
%-------------------------------------------------------------------------

innovation_counter = zeros(ninn,LL); %do not modify this


%-------------------------------------------------------------------------
%   SET VALUES OF INNOVATIONS                  
%-------------------------------------------------------------------------
innov_counter=0; %=1, if you want to set counterfactual values for innovations; =0 otherwise 

if innov_counter ==1
    %the first term on the rhs below is needed to zero out the existing innovations you select and the second term is to replace it with counterfactual values you provide
    %innovation_counter(8,1) = err(8,find(date==2008.0))-0.0033; %  - 2*err(9,find(date==2006.0):find(date==2006.75));
 % innovation_counter(12,:) = -err(12,find(date==2008.0):find(date==2009.75))  +[0.01 0 -0.02 -0.04 -0.04 -0.04 -.04 0]; %[0.2*err(12,find(date==1998.75))*ones(1,1) 0.5*err(12,find(date==1998.75))*ones(1,3) 0.45*err(12,find(date==1998.75))*ones(1,4)];
    %innovation_counter(9,:) = -err(9,find(date==2008.0):find(date==2009.75))  +10*[0.2*err(9,find(date==2001.25))*ones(1,3) 0.4*err(9,find(date==2002.25))*ones(1,2) -0.1*err(9,find(date==2002.25))*ones(1,3)];    
    %innovation_counter(11,:) = [0 0 0 -0.5 -0.5 -0.2 -0.2 -0.2 -0.2 -0.2];%[0 0 0 0 0 0 -0.3 -0.5 -0.6 -0.5];
    %innovation_counter(18,:) = [0 0 -3 -2.5 -2 -2 0 0];
    %-err(5,find(date==2007.5):find(date==2009.75)) + [-0.0255 -.01881 -.006677 0.0069 -.00083 0.0074 -.00064 0.011 0.0046 0.0133 ] ;
end
%-------------------------------------------------------------------------



%-------------------------------------------------------------------------
% SET ybar AND SPECIFIES WHICH VARIABLES AND INNOVATIONS YOU WANT TO USE
%-------------------------------------------------------------------------
%ybar is a matrix containing the values of constrained variables. Dimension: nnxLLL, where nn is the No. of constrained variables. LLL can be =<LL

%aa:vector specifying location of the variables you want to constrain, e.g. aa=[5 14], whose value is defined in ybar. numbering refers to location in full set of observables, not in tauvar
%21: nominal M1 growth, 22: nominal M3 growth; 23= nominal net-worth;
%growth; 24= nominal oil price growth; 25: nominal credit growth; 26: nominal reserves growth

%bb = { %6,  1, 0;
%       24, 1, 0};  %1st column: # of the shock (in full list, not in taushock); 2nd column: patriot; 3rd column is signal; if shock does NOT have signal, 2nd column=1 and 3rd column 0

   
%---------standard financial scenario
% aa = [11 14 23 25];
% 
% bb = {%6,  1, 0;
%       %9,  1, 0;
%       17, 1, 1;
%       19, 1, 0;
%       21, 1, 0};
%   
% YY_baseline = H*xsmooth + repmat(alf(tauvar'),1,size(xsmooth,2)) ; %we do that because for some variables, such as the stock market, the m.e. is not negligible. So, we want to use the "fitted" path rather than the data itself as the baseline
% 
% ybar =  [Y(find(tauvar==11),t1+1:end)+ 0.0015*7/6; %0.0015 amounts to 60 bp rise in premium
%          Y(find(tauvar==14),t1+1:end);  %Re
%           %Y(find(tauvar==8),t1+1:end)+Y(find(tauvar==2),t1+1:end); %M1
%           %Y(find(tauvar==9),t1+1:end)+Y(find(tauvar==2),t1+1:end); %M3
%         [-0.22*0.75 YY_baseline(find(tauvar==1),t1+2:end)+Y(find(tauvar==2),t1+2:end)]; %%-0.107=decline by 8% %-0.17=decline by 15.4% %-0.13=decline by 11.5%
%         %[YY_baseline(find(tauvar==4),t1+1:end)+Y(find(tauvar==2),t1+1:end)]];  %
%           [YY_baseline(find(tauvar==4),t1+1:end)+Y(find(tauvar==2),t1+1:end)-[0.027 0.02 0.015 0.01 0.007 0.002 0.001 0] ]];%[(YY_baseline(find(tauvar==4),t1+1:t1+4)+Y(find(tauvar==2),t1+1:t1+4)-repmat(0.021,1,4))  YY_baseline(find(tauvar==4),t1+5:end)+Y(find(tauvar==2),t1+5:end)]];
% 
% %Note for Camba-Mendez
aa = [4 11 14  23 ]; %25 when nominal credit

bb = {%6,  1, 0;
      %9,  1, 0;
      %5, 1 , 0;
      17, 1, 1;
      19, 1, 0;
      21, 1, 0};
  
YY_baseline = H*xsmooth + repmat(alf(tauvar'),1,size(xsmooth,2)) ; %we do that because for some variables, such as the stock market, the m.e. is not negligible. So, we want to use the "fitted" path rather than the data itself as the baseline

ybar =  [(YY_baseline(find(tauvar==4),t1+1:end) -[0.00211248  0.0040321680  0.0046650540 0.006479986 0.007553949 0.008068907 0.01024838 0.002304617 0.003161327 0.003747416 0.006583525]); %5.5% decline in real credit
          %(YY_baseline(find(tauvar==4),t1+1:end) -[0.00211248  0.0040321680  0.0046650540 0.006479986 0.007553949 0.008068907 0.01024838 0.002304617 0.003161327 0.003747416 0.006583525] + [0.00239334	0.002395937	0.002398708	0.001150531	0.001150886	0.001149115	0.001150708	0.001137373	0.00113764	0.00113504	0.001137829]); %5.5% decline in real credit plus 1.6% rise 
          %(YY_baseline(find(tauvar==4),t1+1:end) + [0.00239334	0.002395937	0.002398708	0.001150531	0.001150886	0.001149115	0.001150708	0.001137373	0.00113764	0.00113504	0.001137829]); %baseline in real credit plus 1.6% rise 
         %(YY_baseline(find(tauvar==4),t1+1:end) -[0.00211248  0.0040321680  0.0046650540 0.006479986 0.007553949 0.008068907 0.01024838 0.002304617 0.003161327 0.003747416 0.006583525] + [0.006102535	0.005268778	0.005794629	0.004502664	0.003747728	0.001690009	0.000898867	0.00467475	0.004054426	0.00117165	0.000798672]); %5.5% decline in real credit plus 3.9% rise 
          Y(find(tauvar==11),t1+1:end); 
          Y(find(tauvar==14),t1+1:end);  %Re
          %Y(find(tauvar==8),t1+1:end)+Y(find(tauvar==2),t1+1:end); %M1
          %Y(find(tauvar==9),t1+1:end)+Y(find(tauvar==2),t1+1:end); %M3
         YY_baseline(find(tauvar==1),t1+1:end)+Y(find(tauvar==2),t1+1:end)]; %%-0.107=decline by 8% %-0.17=decline by 15.4% %-0.13=decline by 11.5%
         %[Y(find(tauvar==4),t1+1:end)+Y(find(tauvar==2),t1+1:end)-[0.01917	0.0142	0.01065	0.0071	0.00497	0.00142	0.00071	0	0	0	0	0	0] ]]; %5.7% restriction
         %[Y(find(tauvar==4),t1+1:end)+Y(find(tauvar==2),t1+1:end)-[0.009315	0.0069	0.005175	0.00345	0.002415	0.00069	0.000345	0	0	0	0	0	0] ]]; %2.8% restriction
         %[-0.016176777 -0.016544837 -0.016884977 -0.022359284 -0.022590529 -0.022813982 -0.023031813 -0.023242438 -0.023447992 -0.023647326 -0.023841147 ] ];
         %(YY_baseline(find(tauvar==20),t1+1:end)  + [0.021684227 0.021223984 0.020782872 0.015308522 0.0150777 0.014853736 0.014636328 0.014425192 0.014220061 0.014020683 0.013826819 ]) ; % [-0.042261925 -0.027053893 -0.036669761 -0.042280076 -0.04894217 -0.038506452 -0.038047539 -0.032528894 -0.049820467 -0.042113293 -0.038977308]] ; %reserves

         

% %Note for president
% aa = [1 2 3 4 5 6 7 9 10 11 12 14 17 18];
% 
% bb = {1,  1, 0;
%       2,  1, 0;
%       6,  1, 0;
%       7,  1, 0;
%       9,  1, 0;
%       13,  1, 0;
%       16,  1, 0;
%       17,  1, 1;
%       18,  1, 0;
%       19,  1, 0;
%       21, 1, 1;
%       22, 1, 0;
%       23, 1, 0;
%       24, 1, 0;
%       25, 1, 0};
  
%YY_baseline = H*xsmooth + repmat(alf(tauvar'),1,size(xsmooth,2)) ; %we do that because for some variables, such as the stock market, the m.e. is not negligible. So, we want to use the "fitted" path rather than the data itself as the baseline
%ybar =  [Y([1:7,9:15],t1+1:end)]; 



%---------financial scenario for note on deflation
% aa = [11 14 23 25]; %[11 14 23 25];
% 
% bb = {%6,  1, 0;
%       %9,  1, 0;
%       17, 1, 1;
%       19, 1, 0;
%       21, 1, 1};
%   
% YY_baseline = H*xsmooth + repmat(alf(tauvar'),1,size(xsmooth,2)) ; %we do that because for some variables, such as the stock market, the m.e. is not negligible. So, we want to use the "fitted" path rather than the data itself as the baseline

% ybar =  [Y(find(tauvar==11),t1+1:end)+ 0.0015*7/6; %0.0015 amounts to 60 bp rise in premium
%          Y(find(tauvar==14),t1+1:end);  %Re
%           %Y(find(tauvar==8),t1+1:end)+Y(find(tauvar==2),t1+1:end); %M1
%           %Y(find(tauvar==9),t1+1:end)+Y(find(tauvar==2),t1+1:end); %M3
%         [ (YY_baseline(find(tauvar==1),t1+1)+Y(find(tauvar==2),t1+1) -0.275*0.75)  YY_baseline(find(tauvar==1),t1+2:end)+Y(find(tauvar==2),t1+2:end) ]; %%-0.107=decline by 8% %-0.17=decline by 15.4% %-0.13=decline by 11.5% 0.22=decline by 20%
%         %[YY_baseline(find(tauvar==4),t1+1:end)+Y(find(tauvar==2),t1+1:end)]];  %
%           [(YY_baseline(find(tauvar==4),t1+1:t1+4)+Y(find(tauvar==2),t1+1:t1+4)-repmat(0.0182,1,4))  YY_baseline(find(tauvar==4),t1+5:end)+Y(find(tauvar==2),t1+5:end)]];

      
%------ 1991Q3-1993Q3 swedish scenario
% aa = [11 14 23 25];
% 
% bb = {17, 1, 1;
%       19, 1, 0;
%       21, 1, 1};
% 
% YY_baseline = H*xsmooth + repmat(alf(tauvar'),1,size(xsmooth,2)) ; %we do that because for some variables, such as the stock market, the m.e. is not negligible. So, we want to use the "fitted" path rather than the data itself as the baseline
% 
% ybar = [ ([175 175 211 236 237 261 210 175]/(400*100) - 0.003569853922285); %premium (demeaned)
%          Y(find(tauvar==14),t1+1:end);  %Re
%          [(YY_baseline(find(tauvar==1),t1+1)+Y(find(tauvar==2),t1+1)-0.1092) YY_baseline(find(tauvar==1),t1+2:end)+Y(find(tauvar==2),t1+2:end)]; %
%        %[YY_baseline(find(tauvar==4),t1+1:end)+Y(find(tauvar==2),t1+1:end)]]; 
%          [YY_baseline(find(tauvar==4),t1+1:end)+Y(find(tauvar==2),t1+1:end)-[0.0205 0.0205 0.0205 0.0205 0.0205 0.005 0 0] ]]; %nominal credit growth (demeaned)

     
% %------ great depression scenario
% aa = [1 4 11 14]; %[1 4 11 14]; %
% 
% bb = {%6, 1, 0; 
%       %9, 1, 0;
%       17, 1, 1; 
%       19, 1, 0;
%       21, 1, 1};
% 
% YY_baseline = H*xsmooth + repmat(alf(tauvar'),1,size(xsmooth,2)) ; %we do that because for some variables, such as the stock market, the m.e. is not negligible. So, we want to use the "fitted" path rather than the data itself as the baseline
% 
% ybar = [ [(YY_baseline(find(tauvar==1),t1+1:t1+5) -0.0871) YY_baseline(find(tauvar==1),t1+6:t1+8)];
%           (YY_baseline(find(tauvar==4),t1+1:t1+8) -0.02003);
%           %repmat(-0.01301,1,8)-0.009257779138235; %0.009257779138235 is the mean of real M1 growth
%           %repmat(-0.0189,1,8)- 0.008229871385055; %0.008229871385055 is the mean of real M3 growth
%           ([183 240 266 330 320 314 267 253]/(400*100) - 0.003569853922285); %premium (demeaned)
%           Y(find(tauvar==14),t1+1:t1+8) ];
   
     
      
%---------computing premium equivalent of credit restriction
% aa = [14 23 25]; %23
% 
% bb = {19, 1,  0;
%       %17, 1, 1};
%       21, 0,  0};
%   
% YY_baseline = H*xsmooth + repmat(alf(tauvar'),1,size(xsmooth,2)) ; %we do that because for some variables, such as the stock market, the m.e. is not negligible. So, we want to use the "fitted" path rather than the data itself as the baseline
% 
% ybar =  [Y(find(tauvar==14),t1+1:end);  %Re
%       %[Y(find(tauvar==1),t1+1:t1+6) YY_baseline(find(tauvar==1),t1+7:end)]+Y(find(tauvar==2),t1+1:end) - [0.00 0.00822 0.00982 0.01285 0.01852 0.02798 -0.00 -0.00 -0.00 -0.00]; %[0.01966 0.01966 0.0229 0.0287 0.0383 0.0534 0.0 0.0 0.0 0.0];
%       %[(YY_baseline(find(tauvar==4),t1+1:t1+6)+Y(find(tauvar==2),t1+1:t1+6)-repmat(0.0067,1,6))  YY_baseline(find(tauvar==4),t1+7)+Y(find(tauvar==2),t1+7)-0.0067*0.75  YY_baseline(find(tauvar==4),t1+8)+Y(find(tauvar==2),t1+8)-0.0067*0.5 YY_baseline(find(tauvar==4),t1+9)+Y(find(tauvar==2),t1+9)-0.0067*0.25  YY_baseline(find(tauvar==4),t1+10)+Y(find(tauvar==2),t1+10)]];
%          [Y(find(tauvar==1),t1+1:t1+6) YY_baseline(find(tauvar==1),t1+7:end)]+Y(find(tauvar==2),t1+1:end) - [0.00 0.008973 0.01001 0.01226 0.01686 0.0248 0.01 -0.015 -0.025 -0.02]; %[0.01 0.01525 0.0166 0.01950 0.02508 -0.01 -0.005 -0.01 -0.03 -0.02]; %[0.01966 0.01966 0.0229 0.0287 0.0383 0.0534 0.0 0.0 0.0 0.0];
%          [(YY_baseline(find(tauvar==4),t1+1:t1+6)+Y(find(tauvar==2),t1+1:t1+6)-repmat(0.0083,1,6))  YY_baseline(find(tauvar==4),t1+7:end)+Y(find(tauvar==2),t1+7:end)]];


%--------condition on (B)MPE technical assumptions 
% aa=[11 12 14 23 24]; 
% bb= {17, 1, 1;  %17, 1, 1;
%      19, 1, 0;
%      21, 1, 0; %%%
%      24, 1, 0;
%      25, 1, 0};
%  
% YY_baseline = H*xsmooth + repmat(alf(tauvar'),1,size(xsmooth,2)) ; %we do that because for some variables, such as the stock market, the m.e. is not negligible. So, we want to use the "fitted" path rather than the data itself as the baseline
% 
% ybar = [Y(find(tauvar==11),t1+1:end); Y(find(tauvar==12),t1+1:end); Y(find(tauvar==14),t1+1:end); (1.2*Y(find(tauvar==1),t1+1:end)+Y(find(tauvar==2),t1+1:end));  Y(find(tauvar==18),t1+1:end)+Y(find(tauvar==2),t1+1:end)];
%

%-------unchanged rate
% ybar =  [Y(find(tauvar==14),t1+1:end)];  %Re --MPE
%          
% aa = [14 ]; 
% bb = {19, 1, 0};  


% %-------------exploiting leading properties of US financial shocks
% %taushock= [1     2     5     6     7     9    13    16    17    18    19    21    22    23    24  25];
% %III=[ 1  3  5  7  9  11  13  15  17  19  21     23  25  26  27  28   29   30   31   32    33  35  37  39];
% %shocks (17,23,25:32,35)
% err_old=err;
% load d:\banking\euroarea_code\results_ea\ea_innivations err err_long %psi z taum taub taus A B1 rho %((based on parameterseuro, estimated ea elasticities, ea policy rule, ea shocks);
% err_ea = err;
% load('d:\banking\euroarea_code\results_ea\us_innovations', 'err')
% err_us = err; %err_us is 40x110 with 110=2008Q2
% 
% %err_long([25:28],111:113) = err_us([25:28],108:110); %scale the innovations 0.63
% err_long(25,111:113) = 0.63*err_us(25,108:110);
% err_long(26:27,111:112) = 0.63*err_us(26:27,109:110);
% err_long(28,111) = 0.63*err_us(28,110);
% err = err_long;
% err = err(III,:);
% %------       


%------high M3 and Credit growth, with policy rate, stock market and premium at baseline
% innovation_counter = zeros(size(D,2),LL);
% aa = [11  14 22 23 25]; %11 14 23
% 
% bb = { 9, 1, 0;
%       17, 1, 1;
%       19, 1, 0;
%       21, 1, 1};  
%   
% YY_baseline = H*xsmooth + repmat(alf(tauvar'),1,size(xsmooth,2)) ; %we do that because for some variables, such as the stock market, the m.e. is not negligible. So, we want to use the "fitted" path rather than the data itself as the baseline
% 
% ybar= [Y(find(tauvar==11),t1+1:end);
%        Y(find(tauvar==14),t1+1:end); 
%        %repmat( (Y(find(tauvar==9),t1-2)+Y(find(tauvar==2),t1-2)+Y(find(tauvar==9),t1-1)+Y(find(tauvar==2),t1-1))/2,1,8); %M3
%        repmat(Y(find(tauvar==9),end)+Y(find(tauvar==2),end),1,11);
%        YY_baseline(find(tauvar==1),t1+1:end)+Y(find(tauvar==2),t1+1:end);
%        [repmat(YY_baseline(find(tauvar==4),t1)+Y(find(tauvar==2),t1),1,6) (YY_baseline(find(tauvar==4),t1+7:end)+Y(find(tauvar==2),t1+7:end))]];

%--------
       




