function get2moments(lam,country,xxnew,par,taumat,her,Rb,Re,c,y,invest,mb, w,l,k,n, infl,g,ev, ...
    taushock,Pe,G,Gp,omegabar,Rk,rk,Gs,fdiff,Xdat,J,ric,M,m1, ...
    currdep,Ra,dm,m3,demean,mm,parstoch,duration1,tauvar,tauvar2,size_a,size_b,prior, ...
    taushock1,gamma,alpha,R,ttt2,entr,taushock3,duration2,params,q,s,u,lambdaz,uzc,vn,Rm,btot,init_kalman,outfolder);

N = 500; %5000;

ia  = 0;
iaa = 1;
KU = 21; %No of parameters related to standard deviation of shock innovations + 4

if country==2;
    ia  = 1; %US model has also shock 5 (demand reserve shock) and an aditional observable: Banks Reserve
    iaa = 0; %US model does not include actil, no Hdoupr 
    KU = KU+ia; 
end


KK = 1:KU;

[g1,g2]=HPSPECT(lam);
j=[0:1:N/2];
omeg=2*pi*j/N;
i=sqrt(-1);
z=exp(-i*omeg);

%Do a test to make sure the spectral calculations are working, by
%verifying that they work on a simple ar(1) process with ar coefficient rho and innovation variance ve.
rho=.9;
ve=1;

%this is the transform of the data when we work with growth rates, rather than the HP filter
JJ=zeros(13+ia,15+ia);
JJ(1,5)=1;
JJ(2,10)=1;
JJ(3,7)=1;
JJ(5,2)=1;
JJ(6,1)=1;
JJ(7,4)=1;
JJ(8,11)=1;
JJ(9,5)=1;
JJ(10,12)=1;
JJ(11,13)=1;
JJ(12,8)=1;
JJ(13,9)=1;
if country==2
    JJ(14,16)=1;
end


if 2*round(N/2) ~= N
    error('fatal (get2moments) must use round number, N')
end
for kk = KK
    kk
    ppar=par;
    xxx = zeros(49+ia,1);
    xxx(1:25+iaa)      = xxnew(1:25+iaa);
%     xxx(41+iaa:end)    = xxnew(41+iaa:end);
%     xxx(26+iaa:41+iaa) = .0000000000001;
    xxx(43:end)    = xxnew(43:end);
    xxx(26+iaa:42) = .0000000000001;

    %kk=21 (22 in US) corresponds to the case in which all shock innovations are switched off with exception of inflation target shock. This case is automatically dealt with (case 21) because we have set above all std in xx to zero and target shock is not estimated but calibrated

    if kk < 17+ia %going through the shock innovations from 1 to 16+ia (as inflation target is not estimated, it is not in xx, so we have 16 rather than 17 shocks when we go through std in xx) 
        ppar(100-iaa)=0; %switching off std1_pitarget which is not in xx
        xxx(25+iaa+kk)=xxnew(25+iaa+kk);
        
    elseif kk == 17+ia || kk == 19+ia  %case 17+ia is with all shock innovations activated but no Measur errors (see below after the call of ssloglik); case 19+ia has also Measur error activated
        xxx(26+iaa:42) = xxnew(26+iaa:42);
        
    elseif kk == 18+ia  %case 18+ia is with both std1_sigma and std2_sigma activated and all other shocks switched off
        ppar(100-iaa) = 0; 
        xxx(37:38) = xxnew(37:38); 
        
    elseif kk == 20+ia %case 20+ia is with all shock innovations switched off, and Measur error activated
        ppar(100-iaa) = 0; 
    end

    %location in xx of the various shock variances:
  %EA:
%     std1_lambdaf   =  xx(27) ;
%     std1_xb        =  xx(28) ;
%     std1_muup      =  xx(29) ;
%     std1_chii      =  xx(30) ;
%     std1_g         =  xx(31) ;
%     std1_muzstar   =  xx(32) ;
%     std1_gamma     =  xx(33) ;
%     std2_gamma     =  xx(34) ;
%     std1_epsil     =  xx(35) ;
%     std1_xp        =  xx(36) ;
%     std1_sigma     =  xx(37) ;
%     std2_sigma     =  xx(38) ;
%     std1_zetac     =  xx(39) ;
%     std1_zetai     =  xx(40) ;
%     std1_tauo      =  xx(41) ;
%     std1_term      =  xx(42) ;
  %US:
%     std1_lambdaf   =  xx(26) ;
%     std1_xi        =  xx(27) :
%     std1_xb        =  xx(28) ;
%     std1_muup      =  xx(29) ;
%     std1_chii      =  xx(30) ;
%     std1_g         =  xx(31) ;
%     std1_muzstar   =  xx(32) ;
%     std1_gamma     =  xx(33) ;
%     std2_gamma     =  xx(34)
%     std1_epsil     =  xx(35) ;
%     std1_xp        =  xx(36) ;
%     std1_sigma     =  xx(37) ;
%     std2_sigma     =  xx(38) ;
%     std1_zetac     =  xx(39) ;
%     std1_zetai     =  xx(40) ;
%     std1_tauo      =  xx(41) ;
%     std1_term      =  xx(42) ;
  

    xxx=imap(xxx);
    [floglik,cost_flag,H,F,Q,initV,is,alf,RR,V_eps]   =  ssloglik(xxx,ppar,taumat,her,Rb,Re,c,y,invest,mb, w,l,k,n, infl,g,ev, ...
        taushock,Pe,G,Gp,omegabar,Rk,rk,Gs,fdiff,Xdat,J,ric,M,m1, ...
        currdep,Ra,dm,m3,demean,mm,parstoch,duration1,tauvar,tauvar2,size_a,size_b,prior, ...
        taushock1,gamma,alpha,R,ttt2,entr,taushock3,duration2,params,q,s,u,lambdaz,uzc,vn,Rm,btot,init_kalman);
    Rmeas=zeros(size(RR));
    if kk == 19+ia || kk == 20+ia
        Rmeas=RR;
    end
    fJ=zeros(13+ia,15+ia);
    ftild=(-g2*(1-z).*(1-1./z).*(1-1./z)./((1-g1*z-g2*z.^2).*(1-g1./z-g2./z.^2)));
    f=real(ftild.*(1-z));
    for ii = 1:N/2+1        
        JJ(9,3)=-(1-z(ii));
        JJ(4,3)=1-z(ii);
        fJ(1,5)=ftild(ii);
        fJ(2,10)=ftild(ii);
        fJ(3,7)=ftild(ii);
        fJ(4,3)=f(ii);
        fJ(5,2)=1;
        fJ(6,1)=ftild(ii);
        fJ(7,4)=ftild(ii);
        fJ(8,11)=ftild(ii);
        fJ(9,3)=-f(ii);
        fJ(9,5)=ftild(ii);
        fJ(10,12)=f(ii);
        fJ(11,13)=f(ii);
        fJ(12,8)=ftild(ii);
        fJ(13,9)=ftild(ii);
        if country==2
            fJ(14,16)=ftild(ii);
        end
        S=fJ*H*inv(eye(size(F,1))-F*z(ii))*Q*inv(eye(size(F,1))-F'/z(ii))*H'*fJ'+fJ*Rmeas*fJ';
        SD=JJ*H*inv(eye(size(F,1))-F*z(ii))*Q*inv(eye(size(F,1))-F'/z(ii))*H'*JJ'+JJ*Rmeas*JJ';
        s=ve/(1+rho^2-2*rho*cos(omeg(ii)));%this is the little ar(1) along for the ride as a check
        if ii == 1
            C0=S;
            C1=S;
            c0=s;
            c1=s;
            CD0=SD;
            CD1=SD;
        elseif ii > 1 & ii < N/2+1
            C0=C0+(S+transpose(S));
            C1=C1+(S/z(ii)+transpose(S)*z(ii));
            CD0=CD0+(SD+transpose(SD));
            CD1=CD1+(SD/z(ii)+transpose(SD)*z(ii));
            c0=c0+2*s;
            c1=c1+2*s*cos(omeg(ii));
        elseif ii == N/2+1
            C0=C0+S;
            C1=C1+S/z(ii);
            CD0=CD0+SD;
            CD1=CD1+SD/z(ii);
            c0=c0+s;
            c1=c1+s/z(ii);
        end
    end
    C0=C0/N;
    C1=C1/N;
    CD0=CD0/N;
    CD1=CD1/N;

    
    c0=c0/N;
    c1=c1/N;
    if abs(c0-ve/(1-rho^2)) > .1e-9 | abs(c1-rho*ve/(1-rho^2)) > .1e-9
        error('fatal (get2moments) spectral approximation to second moments shows evidence of inaccuracy, increase N')
    end
    
    %the following corresponds to the HP filter-based statistics:
    V    = diag(C0);
    corr = diag(C1);
    sy   = sqrt(C0(1,1));
    %relative standard deviation, Ex_t*y_t+1, Ex_t*y_t, Ex_t*y_t-1, variance
    Mod  = [[sqrt(V(1)); sqrt(V(2:end)/V(1))] C1(1,1:end)'./sqrt(V(1)*V(1:end)) C0(1,1:end)'./sqrt(V(1)*V(1:end)) C1(1:end,1)./sqrt(V(1)*V(1:end)) V];    
    t1   = ['sy',num2str(kk),'=sy'];
    if max(max(abs(imag(Mod)./real(Mod)))) > 1e-8 | abs(imag(sy)) > .1e-10
        error('fatal (get2moments) complex second moments')
    else
        Mod = real(Mod);
        sy  = real(sy);
    end
    d = diag(V_eps);
    
    tt=['Mod',num2str(kk),'=Mod;'];
    tz=['Q',num2str(kk),'=Q;'];
    ty=['d',num2str(kk),'=d;'];
    eval(tt);
    eval(tz);
    eval(ty);
    eval(t1);
    
    %the following corresponds to the first difference filter-based statistics:
    VD=diag(CD0);
    corrD=diag(CD1);
    syD=sqrt(CD0(1,1));
    ModD=[[sqrt(VD(1)); sqrt(VD(2:end)/VD(1))] CD1(1:end,1)./sqrt(VD(1)*VD(1:end)) CD0(1,1:end)'./sqrt(VD(1)*VD(1:end)) CD1(1,1:end)'./sqrt(VD(1)*VD(1:end)) VD];    
    t1=['syD',num2str(kk),'=syD'];
    if max(max(abs(imag(ModD)./real(ModD)))) > .1e-9 | abs(imag(syD)) > .1e-10
        error('fatal (get2moments) complex second moments')
    else
        ModD=real(ModD);
        syD=real(syD);
    end
    d=diag(V_eps);
    tt=['ModD',num2str(kk),'=ModD;'];
    eval(tt);
    eval(t1);
end

if country==1
    save([outfolder '\second_Mod_ea'], 'Mod1', 'Mod2', 'Mod3', 'Mod4', 'Mod5', 'Mod6', 'Mod7', 'Mod8', 'Mod9', 'Mod10', 'Mod11', 'Mod12', 'Mod13', 'Mod14', 'Mod15', 'Mod17', 'Mod16', ...
        'Mod18', 'Mod19', 'Mod20', 'Mod21', 'sy1', 'sy2', 'sy3', 'sy4', 'sy5', 'sy6', 'sy7', 'sy8', 'sy9', 'sy10', 'sy11', 'sy12', 'sy13', 'sy14', 'sy15', 'sy16', 'sy17', 'sy18', 'sy19', ...
        'sy20', 'sy21', 'Q1', 'Q2', 'Q3', 'Q4', 'Q5', 'Q6', 'Q7', 'Q8', 'Q9', 'Q10', 'Q11', 'Q12', 'Q13', 'Q14', 'Q15', 'Q16', 'Q17', 'Q18', 'Q19', 'Q20', 'Q21', ...
        'd1', 'd2', 'd3', 'd4', 'd5', 'd6', 'd7', 'd8', 'd9', 'd10', 'd11', 'd12', 'd13', 'd14', 'd15', 'd16', 'd17', 'd18', 'd19', 'd20', 'd21', ...
        'ModD1', 'ModD2', 'ModD3', 'ModD4', 'ModD5', 'ModD6', 'ModD7', 'ModD8', 'ModD9', 'ModD10', 'ModD11', 'ModD12', 'ModD13', 'ModD14', 'ModD15', 'ModD16', 'ModD17', ...
        'ModD18', 'ModD19', 'ModD20',  'ModD21', 'syD1', 'syD2', 'syD3', 'syD4', 'syD5', 'syD6', 'syD7', 'syD8', 'syD9', 'syD10', 'syD11', 'syD12', 'syD13', 'syD14', 'syD15', 'syD16', ...
        'syD17', 'syD18', 'syD19', 'syD20', 'syD21','KU','ia','iaa');
elseif country == 2
    save([outfolder '\second_Mod_us'], 'Mod1', 'Mod2', 'Mod3', 'Mod4', 'Mod5', 'Mod6', 'Mod7', 'Mod8', 'Mod9', 'Mod10', 'Mod11', 'Mod12', 'Mod13', 'Mod14', 'Mod15', 'Mod16', 'Mod17', ...
        'Mod18', 'Mod19', 'Mod20', 'Mod21', 'Mod22', 'sy1', 'sy2', 'sy3', 'sy4', 'sy5', 'sy6', 'sy7', 'sy8', 'sy9', 'sy10', 'sy11', 'sy12', 'sy13', 'sy14', 'sy15', 'sy16', 'sy17', 'sy18', 'sy19', ...
        'sy20', 'sy21', 'sy22', 'Q1', 'Q2', 'Q3', 'Q4', 'Q5', 'Q6', 'Q7', 'Q8', 'Q9', 'Q10', 'Q11', 'Q12', 'Q13', 'Q14', 'Q15', 'Q16', 'Q17', 'Q18', 'Q19', 'Q20', 'Q21', 'Q22', ...
        'd1', 'd2', 'd3', 'd4', 'd5', 'd6', 'd7', 'd8', 'd9', 'd10', 'd11', 'd12', 'd13', 'd14', 'd15', 'd16', 'd17', 'd18', 'd19', 'd20', 'd21', 'd22', ...
        'ModD1', 'ModD2', 'ModD3', 'ModD4', 'ModD5', 'ModD6', 'ModD7', 'ModD8', 'ModD9', 'ModD10', 'ModD11', 'ModD12', 'ModD13', 'ModD14', 'ModD15', 'ModD16', 'ModD17', ...
        'ModD18', 'ModD19', 'ModD20', 'ModD21', 'ModD22', 'syD1', 'syD2', 'syD3', 'syD4', 'syD5', 'syD6', 'syD7', 'syD8', 'syD9', 'syD10', 'syD11', 'syD12', 'syD13', 'syD14', 'syD15', 'syD16', ...
        'syD17', 'syD18', 'syD19', 'syD20', 'syD21', 'syD22','KU','ia','iaa');
end