clear all
close all

larry=-1;
if larry == 0 | larry == -1
    setpathrobbie   % roberto's
elseif larry == 1
    setpath  % larry's path
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
accuracy  = 6.4e-7;%1.03e-6;
icheck=0;%if 1, then check the analytic derivatives by comparing them with derivatives obtained numerically
         %check is done for benchmark model, regardless of value of entr
rpl=1; %if you want Leontief production function for bank deposits, set rp1=0 here and rhobank<0 in parameterstemp (parameterseuro)
depression=3;
        
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

[rho,phi,xb,psiL,ksi,sigmaL,v,sigmaq,theta,Hdoupr,b,xiw,lambdaw,muzstar,Sdoupr,sigmaa,xip,psik,psil,delta,alpha,lambdaf,gamma, ...
        mu,sigma,tau,tauc,tauk,taul,we,x,tauT,tauD,zeta, ...
        vl,Fomegabar,beta,xi,pi,R,Re,Ra,her,Rk,rk,omegabar,Gamma,G,n,k,i,w,l,c,uzc,m,mb,lambdaz,costs,erz,ev, ...
        hkb,g,y,Rb,Pe,Gammap,Gammadp,Gammas,Gammaps,Gp,Gdp,Gs,Gps,lambda,lamz,params,Taylor,forward,money,rhobank, ...
        q,s,u,Rm,dm,chii,vn,RT,upsil,chorse,bigtheta,muup,m3,m1,currdep,D,etag,eps_shock,entr] = steadystate(depression);
kbar=k;

al1=-.5/x;
al2=-.5/x;
al3=0;
al4=0;
al5=0;
al6=0;  
rhox=.2;  
fdiff=0;
N=21;

if Taylor > 2
    error('fatal (solvemodel) simulation code not ready for Monetary Base Rule')
end
[alphas,alpha_2, alpha_1, alpha_0,betas,taumat,sst,ss,M] ...
    = canonicalform(lambdaz,g, her,xi,pi,i,omegabar,Rk,n,ev,mb,uzc,lamz,Ra,c,w,kbar,Re,m3,k,params,q,s,u,dm,vn,RT,Rm,icheck,money,rpl, ...
    Taylor,forward,tau,ksi,Rb,y,m,x,psil,l,psik,rk,muzstar,Pe,G,Gp,Gs,sigma,fdiff,N,al1,al2,al3,al4,al5,al6,rhox,larry);

%Construct rho. There are only 2 shocks: an ARMA(1,3) representation of epsilon and a AR(1) shock which we use to undue epsilon
rho=zeros(5,5); 
rho(1,1)=0.8; %rhoepsilon
rho(1,4)=1; 
rho(3,2)=1; 
rho(4,3)=1;
rho(5,5)=0.8; 
%construct D
D=[0 1 0 0 0 ;0 0 0 0 1]';

%construct the RBC version of the model and compute impulse responses to an expected shock that does not realise
[out_R,inv_R,realrate_R,q_R,c_R,l_R,wage_R]=RBC(rho,D,pi,muzstar,beta,tauD,tauk,upsil,delta,lambdaf,alpha,b,taul,tauc, ...
                                 lambdaw,zeta,psiL,etag,Sdoupr,sigmaa,sigmaL);

%construct betas
if entr==1
    beta_0=zeros(27,5);
    beta_1=zeros(27,5);
    beta_1(2,1)=-1; %equation 2 gives an expression for the marginal cost
    beta_1(2,5)=-1;
    beta_1(10,1)=-1; % equation 10 corrsponds to equation 3 in the manuscript (another condition on the marginal cost). they are interchanged at the bottom of makelphabeta
    beta_1(10,5)=-1;
    beta_1(11,1)=-1; %equation 11 corresponds to equation 20 in the manuscript (the resource constraint). they are interchanged at the bottom of makelphabeta
    beta_1(11,5)=-1;
    
    betas=[beta_0 beta_1];
    taumat   =   ones(27,5); %don't exclude anything
    taumat   =   taumat';
elseif entr==0
    beta_0=zeros(25,5);
    beta_1=zeros(25,5);
    beta_1(2,1)=-1;
    beta_1(2,5)=-1;
    beta_1(3,1)=-1;
    beta_1(3,5)=-1;
    beta_1(15,1)=-1; %this correswponds to eq. 20 (resourse constraint) in the manuscript
    beta_1(15,5)=-1;
    
    betas=[beta_0 beta_1];
    taumat   =   ones(25,5); %don't exclude anything
    taumat   =   taumat';
elseif entr ==-1
    beta_0=zeros(16,5);
    beta_1=zeros(16,5);
    beta_1(2,1)=-1;
    beta_1(2,5)=-1;
    beta_1(3,1)=-1;
    beta_1(3,5)=-1;
    beta_1(10,1)=-1; %this corresponds to eq. 20 (resource constraint) in the manuscript
    beta_1(10,5)=-1;
    
    betas=[beta_0 beta_1];
    taumat   =   ones(16,5); %don't exclude anything
    taumat   =   taumat';    
end    

%
%d = mu*kbar*(1+Rk)*G/(pi*muzstar);
c_y = c/y;
i_y = i/y;
%
    
Time=21; %although we plot below 20 period in the impulse responses, we compute 21 periods in order to construct the real rate at period 20 (which is a function of inflation at period 21)
[z1,yhat,infhat,ihat,nhatp,qhat,chat,what,lhat,Rehatp,m3hat,premiumhat]  = issingsimulate(alphas,alpha_0,alpha_1,alpha_2, ...
    betas,rho,D,taumat,c_y,i_y,Time,accuracy,entr,Gp,omegabar,G,Rk,k,n,alpha);

%plot impulse responses
tt=1:20;
if entr==1
    doplot(tt,entr,pi,Pe,out_R,yhat,[],[],infhat,[],[],inv_R,ihat,[],[],q_R,qhat,[],[],c_R,chat,[],[],wage_R,what,[],[],l_R,lhat,[],[],realrate_R,Rehatp,[],[],nhatp,m3hat,premiumhat);
end

if entr==1
    premiumhat=premiumhat*Pe*400*100;
    save c:\banking\euroarea_code\issing yhat infhat ihat nhatp qhat chat what lhat Rehatp m3hat premiumhat
elseif entr ==0
    yhat_e=yhat; infhat_e=infhat; ihat_e=ihat; qhat_e=qhat; chat_e=chat; what_e=what; lhat_e=lhat; Rehatp_e=Rehatp; 
    save c:\banking\euroarea_code\issing_e yhat_e infhat_e ihat_e qhat_e chat_e what_e lhat_e Rehatp_e
elseif entr==-1
    yhat_b=yhat; infhat_b=infhat; ihat_b=ihat; qhat_b=qhat; chat_b=chat; what_b=what; lhat_b=lhat; Rehatp_b=Rehatp;
    load c:\banking\euroarea_code\issing yhat infhat ihat nhatp qhat chat what lhat Rehatp m3hat premiumhat
    load c:\banking\euroarea_code\issing_e yhat_e infhat_e ihat_e qhat_e chat_e what_e lhat_e Rehatp_e
    doplot(tt,entr,pi,Pe,out_R,yhat,yhat_e,yhat_b,infhat,infhat_e,infhat_b,inv_R,ihat,ihat_e,ihat_b,q_R,qhat,qhat_e,qhat_b, ...
        c_R,chat,chat_e,chat_b,wage_R,what,what_e,what_b,l_R,lhat,lhat_e,lhat_b,realrate_R,Rehatp,Rehatp_e,Rehatp_b,nhatp,m3hat,premiumhat);
end

do_variance=0;
if do_variance == 1
    Time=200;
    rhotil=0.8;
    aytil=0;
    amtil=0;
    results=[];
    noresults=[];
    for aptil=0.5:0.3:4
        try
            [zz1,outputt]=issingsimulate(rhotil,aptil,aytil,amtil,alpha_0,alpha_1,alpha_2,betas,rho,D,taumat,pi,Rb,muzstar,R,Ra,RT, ...
                c_y,i_y,Time,accuracy,entr);

            var_pi = zz1(1,:)*zz1(1,:)';
            var_y  = (outputt(1:200)-out_R(1:200))*(outputt(1:200)-out_R(1:200))';
            results=[results; aptil var_pi var_y];
        catch
            lasterr
            lasterr('')
            noresults=[noresults; aptil];
        end
    end
    %plot trade-off
    figure
    plot(results(:,2),results(:,3),'b.-')
    xlabel('var(inflation)')
    ylabel('var(y-y(RBC)')
    String2=['Trade-off'];
    hout=suptitle(String2);
    
end