function maketable2moments(country,cc_ea,Mod,lab,fid,hp)


fprintf(fid,'\\begin{equation*}\n');
fprintf(fid,'\\begin{tabular}{lllll}\n');
if country == 1
    if hp == 1
        tt=['\\multicolumn{5}{l}{Table: Second moment properties, EA data and model (HP filtered), shock - ',lab,'} \\\\ \n'];
    else
        tt=['\\multicolumn{5}{l}{Table: Second moment properties, EA data and model (differencing), shock - ',lab,'} \\\\ \n'];
    end
elseif country == 2
    if hp == 1
        tt=['\\multicolumn{5}{l}{Table: Second moment properties, US data and model (HP filtered), shock - ',lab,'} \\\\ \n'];
    else
        tt=['\\multicolumn{5}{l}{Table: Second moment properties, US data and model (differencing), shock - ',lab,'} \\\\ \n'];
    end
end
fprintf(fid,tt);
fprintf(fid,'& $\\frac{\\sigma _{x}}{\\sigma _{y}}$ & corr$\\left( x_{t},y_{t+1}\\right) $ & corr$\\left( x_{t},y_{t}\\right) $ & corr$\\left( x_{t},y_{t-1}\\right) $ \\\\ \n');
fprintf(fid,'& \\multicolumn{4}{c}{$x_{t}=y_{t}$} \\\\ \n');
ix=1;
%when you get the standard errors for the standard deviation and
%correlation of output, uncomment these lines and delete the subsequent two
%lines
%A=[cc_ea(ix,1) cc_ea(ix+1,1) cc_ea(ix,3) cc_ea(ix+1,3) cc_ea(ix,4) cc_ea(ix+1,4) cc_ea(ix,5) cc_ea(ix+1,5)];
%fprintf(fid,'data & %6.4f (%5.2f)  &  %5.2f (%5.2f) & %5.2f (%5.2f)  & %5.2f (%5.2f) \\\\ \n',A); 

A=[cc_ea(ix,1) cc_ea(ix,3) cc_ea(ix,4) cc_ea(ix,5)];
fprintf(fid,'data & %6.4f  &  %5.2f & %5.2f  & %5.2f  \\\\ \n',A); 

fprintf(fid,'model & %6.4f  &  %5.2f & %5.2f  & %5.2f  \\\\ \n',Mod(1,1:4)); 

fprintf(fid,'& \\multicolumn{4}{c}{$x_{t}=c_{t}$} \\\\ \n');
ix=3;
A=[cc_ea(ix,1) cc_ea(ix+1,1) cc_ea(ix,3) cc_ea(ix+1,3) cc_ea(ix,4) cc_ea(ix+1,4) cc_ea(ix,5) cc_ea(ix+1,5)];

fprintf(fid,'data & %5.2f (%5.2f)  &  %5.2f (%5.2f) & %5.2f (%5.2f)  & %5.2f (%5.2f)  \\\\ \n',A); 
fprintf(fid,'model & %5.2f  &  %5.2f & %5.2f  & %5.2f  \\\\ \n',Mod(2,1:4)); 
fprintf(fid,'& \\multicolumn{4}{c}{$x_{t}=I_{t}$} \\\\ \n'); 
ix=5;
A=[cc_ea(ix,1) cc_ea(ix+1,1) cc_ea(ix,3) cc_ea(ix+1,3) cc_ea(ix,4) cc_ea(ix+1,4) cc_ea(ix,5) cc_ea(ix+1,5)];
fprintf(fid,'data & %5.2f (%5.2f)  &  %5.2f (%5.2f) & %5.2f (%5.2f)  & %5.2f (%5.2f)  \\\\  \n',A);
fprintf(fid,'model & %5.2f  &  %5.2f & %5.2f  & %5.2f  \\\\ \n',Mod(3,1:4)); 
fprintf(fid,'& \\multicolumn{4}{c}{$x_{t}=h_{t}$} \\\\ \n');
ix=7;
A=[cc_ea(ix,1) cc_ea(ix+1,1) cc_ea(ix,3) cc_ea(ix+1,3) cc_ea(ix,4) cc_ea(ix+1,4) cc_ea(ix,5) cc_ea(ix+1,5)];
 fprintf(fid,'data & %5.2f (%5.2f)  &  %5.2f (%5.2f) & %5.2f (%5.2f)  & %5.2f (%5.2f)  \\\\ \n',A); 
fprintf(fid,'model & %5.2f  &  %5.2f & %5.2f  & %5.2f  \\\\ \n',Mod(4,1:4)); 
fprintf(fid,'& \\multicolumn{4}{c}{$x_{t}=\\pi _{t}$} \\\\ \n');
ix=9;
A=[cc_ea(ix,1) cc_ea(ix+1,1) cc_ea(ix,3) cc_ea(ix+1,3) cc_ea(ix,4) cc_ea(ix+1,4) cc_ea(ix,5) cc_ea(ix+1,5)];
fprintf(fid,'data & %5.2f (%5.2f)  &  %5.2f (%5.2f) & %5.2f (%5.2f)  & %5.2f (%5.2f)  \\\\ \n',A); 
fprintf(fid,'model & %5.2f  &  %5.2f & %5.2f  & %5.2f  \\\\ \n',Mod(5,1:4)); 
fprintf(fid,'& \\multicolumn{4}{c}{$x_{t}=$equity} \\\\ \n'); 
ix=11;
A=[cc_ea(ix,1) cc_ea(ix+1,1) cc_ea(ix,3) cc_ea(ix+1,3) cc_ea(ix,4) cc_ea(ix+1,4) cc_ea(ix,5) cc_ea(ix+1,5)];
fprintf(fid,'data & %5.2f (%5.2f)  &  %5.2f (%5.2f) & %5.2f (%5.2f)  & %5.2f (%5.2f)  \\\\ \n',A); 
fprintf(fid,'model & %5.2f  &  %5.2f & %5.2f  & %5.2f  \\\\ \n',Mod(6,1:4)); 
fprintf(fid,'& \\multicolumn{4}{c}{$x_{t}=$credit} \\\\ \n'); 
ix=13;
A=[cc_ea(ix,1) cc_ea(ix+1,1) cc_ea(ix,3) cc_ea(ix+1,3) cc_ea(ix,4) cc_ea(ix+1,4) cc_ea(ix,5) cc_ea(ix+1,5)];
fprintf(fid,'data & %5.2f (%5.2f)  &  %5.2f (%5.2f) & %5.2f (%5.2f)  & %5.2f (%5.2f)  \\\\ \n',A); 
fprintf(fid,'model & %5.2f  &  %5.2f & %5.2f  & %5.2f  \\\\ \n',Mod(7,1:4)); 
fprintf(fid,'& \\multicolumn{4}{c}{$x_{t}=$risk premium} \\\\ \n'); 
ix=15;
A=[cc_ea(ix,1) cc_ea(ix+1,1) cc_ea(ix,3) cc_ea(ix+1,3) cc_ea(ix,4) cc_ea(ix+1,4) cc_ea(ix,5) cc_ea(ix+1,5)];
fprintf(fid,'data & %5.2f (%5.2f)  &  %5.2f (%5.2f) & %5.2f (%5.2f)  & %5.2f (%5.2f)  \\\\ \n',A); 
fprintf(fid,'model & %5.2f  &  %5.2f & %5.2f  & %5.2f  \\\\ \n',Mod(8,1:4)); 
fprintf(fid,'& \\multicolumn{4}{c}{$x_{t}=$labor productivity} \\\\ \n');
ix=17;
A=[cc_ea(ix,1) cc_ea(ix+1,1) cc_ea(ix,3) cc_ea(ix+1,3) cc_ea(ix,4) cc_ea(ix+1,4) cc_ea(ix,5) cc_ea(ix+1,5)];  
fprintf(fid,'data & %5.2f (%5.2f)  &  %5.2f (%5.2f) & %5.2f (%5.2f)  & %5.2f (%5.2f)  \\\\ \n',A); 
fprintf(fid,'model & %5.2f  &  %5.2f & %5.2f  & %5.2f \\\\  \n',Mod(9,1:4)); 
fprintf(fid,'& \\multicolumn{4}{c}{$x_{t}=$term structure} \\\\ \n');
ix=19;
A=[cc_ea(ix,1) cc_ea(ix+1,1) cc_ea(ix,3) cc_ea(ix+1,3) cc_ea(ix,4) cc_ea(ix+1,4) cc_ea(ix,5) cc_ea(ix+1,5)];  
fprintf(fid,'data & %5.2f (%5.2f)  &  %5.2f (%5.2f) & %5.2f (%5.2f)  & %5.2f (%5.2f)  \\\\ \n',A); 
fprintf(fid,'model & %5.2f  &  %5.2f & %5.2f  & %5.2f \\\\ \n',Mod(10,1:4));
fprintf(fid,'& \\multicolumn{4}{c}{$x_{t}=$interest rate} \\\\ \n');
ix=21;
A=[cc_ea(ix,1) cc_ea(ix+1,1) cc_ea(ix,3) cc_ea(ix+1,3) cc_ea(ix,4) cc_ea(ix+1,4) cc_ea(ix,5) cc_ea(ix+1,5)];  
fprintf(fid,'data & %5.2f (%5.2f)  &  %5.2f (%5.2f) & %5.2f (%5.2f)  & %5.2f (%5.2f)  \\\\ \n',A); 
fprintf(fid,'model & %5.2f  &  %5.2f & %5.2f  & %5.2f \\\\  \n',Mod(11,1:4));
fprintf(fid,'& \\multicolumn{4}{c}{$x_{t}=$real M1} \\\\ \n');
ix=23;
A=[cc_ea(ix,1) cc_ea(ix+1,1) cc_ea(ix,3) cc_ea(ix+1,3) cc_ea(ix,4) cc_ea(ix+1,4) cc_ea(ix,5) cc_ea(ix+1,5)];  
fprintf(fid,'data & %5.2f (%5.2f)  &  %5.2f (%5.2f) & %5.2f (%5.2f)  & %5.2f (%5.2f)  \\\\ \n',A); 
fprintf(fid,'model & %5.2f  &  %5.2f & %5.2f  & %5.2f \\\\ \n',Mod(12,1:4));
fprintf(fid,'& \\multicolumn{4}{c}{$x_{t}=$real M3} \\\\ \n');
ix=25;
A=[cc_ea(ix,1) cc_ea(ix+1,1) cc_ea(ix,3) cc_ea(ix+1,3) cc_ea(ix,4) cc_ea(ix+1,4) cc_ea(ix,5) cc_ea(ix+1,5)];  
fprintf(fid,'data & %5.2f (%5.2f)  &  %5.2f (%5.2f) & %5.2f (%5.2f)  & %5.2f (%5.2f)  \\\\ \n',A); 
if country == 1
    fprintf(fid,'model & %5.2f  &  %5.2f & %5.2f  & %5.2f  \n',Mod(13,1:4));
else
    fprintf(fid,'model & %5.2f  &  %5.2f & %5.2f  & %5.2f \\\\ \n',Mod(13,1:4));
    fprintf(fid,'& \\multicolumn{4}{c}{$x_{t}=$real, nonborrowed reserves} \\\\ \n');
    ix=27;
    A=[cc_ea(ix,1) cc_ea(ix+1,1) cc_ea(ix,3) cc_ea(ix+1,3) cc_ea(ix,4) cc_ea(ix+1,4) cc_ea(ix,5) cc_ea(ix+1,5)];
    fprintf(fid,'data & %5.2f (%5.2f)  &  %5.2f (%5.2f) & %5.2f (%5.2f)  & %5.2f (%5.2f)  \\\\ \n',A);
    fprintf(fid,'model & %5.2f  &  %5.2f & %5.2f  & %5.2f \n',Mod(14,1:4));
end

fprintf(fid,'\\end{tabular}%%\n');
fprintf(fid,'\\end{equation*}\n');

