function plotpsikal(psismooth,zz1smooth,xinosmooth,XXXsmooth,Xdat,Fmle,taushock,tauvar,parstoch,entr, ...
    date,start_estimation,end_estimation,init_kalman,shockss,ssvalues,shock_trans,fdiff,J,l_z,l_psi,l_x, ...
    outfolder,cdir)

[nameshocks,nameXXX] = getnames(fdiff);

figure('name','shocks'), orient landscape
n1=3;
n2=3;
if length(taushock) > 9
    n1=6;
    n2=4;
end

tt=5:length(date);

[vbname,signal_on,III,IIII]=findnum(taushock,parstoch,l_psi,shockss);
 
for ii=1:length(taushock)

    select1=III(ii);
    select2=taushock(ii);

    if taushock(ii) == 1
        subplot(n1,n2,ii)
        plot(date(tt),100*(psismooth(select1,tt)))
        title(nameshocks(1,:))
        ylabel('%dev. from s.s.')
        %set (gca,'XTick',[0 20])

    elseif taushock(ii) == 2
        subplot(n1,n2,ii)
        plot(date(tt),400*(ssvalues(select2)*exp(psismooth(select1,tt))-1))
        title([deblank(nameshocks(2,:)) ', APR']);
        ylabel('Level')
        %set (gca,'XTick',[0 20])

    elseif taushock(ii) == 7
        subplot(n1,n2,ii)
        plot(date(tt),ssvalues(select2)*exp(psismooth(select1,tt)))
        title(nameshocks(7,:));
        ylabel('Level')
        %set (gca,'XTick',[0 20])

    elseif taushock(ii) == 12
        subplot(n1,n2,ii)
        plot(date(tt),exp(psismooth(select1,tt)))
        title(nameshocks(12,:));
        ylabel('Ratio to s.s.')
        %set (gca,'XTick',[0 20])

    elseif taushock(ii) == 13
        subplot(n1,n2,ii)
        plot(date(tt),100*(psismooth(select1,tt)))
        title(nameshocks(13,:))
        ylabel('%dev. from s.s.')
        %set (gca,'XTick',[0 20])

    elseif taushock(ii) == 14
        subplot(n1,n2,ii)
        plot(date(tt),100*(psismooth(select1,tt)))
        title(nameshocks(14,:));
        ylabel('%dev. from s.s.')
        %set (gca,'XTick',[0 20])

    elseif taushock(ii) == 18
        subplot(n1,n2,ii)
        plot(date(tt),ssvalues(select2)*exp(psismooth(select1,tt)))
        title(nameshocks(18,:));
        ylabel('Level')
        %set (gca,'XTick',[0 20])

    elseif taushock(ii) == 19
        subplot(n1,n2,ii)
        plot(date(tt),100*(psismooth(select1,tt)))
        title([deblank(nameshocks(19,:)) ' (basis points)']);
        ylabel('Level')
        %set (gca,'XTick',[0 20])

    elseif taushock(ii) == 21
        subplot(n1,n2,ii)
        plot(date(tt),ssvalues(select2)*exp(psismooth(select1,tt)))
        title(nameshocks(21,:));
        ylabel('Level')
        %set (gca,'XTick',[0 20])

    elseif taushock(ii) == 22
        subplot(n1,n2,ii)
        plot(date(tt),exp(psismooth(select1,tt)))
        title(nameshocks(22,:));
        ylabel('Ratio to s.s.')

    elseif taushock(ii) == 23
        subplot(n1,n2,ii)
        plot(date(tt),exp(psismooth(select1,tt)))
        title(nameshocks(23,:));
        ylabel('Ratio to s.s.')
        %set (gca,'XTick',[0 20])

    elseif taushock(ii) == 24
        subplot(n1,n2,ii)
        plot(date(tt),exp(psismooth(select1,tt)))
        title(nameshocks(24,:));
        ylabel('Ratio to s.s.')

    elseif taushock(ii) ==25
        subplot(n1,n2,ii)
        plot(date(tt),exp(psismooth(select1,tt)))
        title(nameshocks(25,:));
        ylabel('Ratio to s.s.')
        %set (gca,'XTick',[0 20])

    else

        if max(shock_trans==taushock(ii)) == 1
            steadyx=-log((1/ssvalues(select2))-1);
            shockx=psismooth(select1,tt)+steadyx;
            yy=1./(1+exp(-shockx));

            subplot(n1,n2,ii)
            %           plot(date(tt),yy,'-',date(tt),ssvalues(select2)* ...
            %               exp((1-ssvalues(select2))*psismooth(select1,tt)),':')

            %           title([texlabel(nameshocks(select2,:)),'nonlinear (-) linear (..)']);
            plot(date(tt),ssvalues(select2)*exp((1-ssvalues(select2))*psismooth(select1,tt)))

            if taushock(ii) == 17
                title(nameshocks(17,:));
                ylabel('Fraction')
                %set (gca,'XTick',[0 20])

            elseif taushock(ii) == 8
                title('Money Demand, \theta_{t}');
                ylabel('Fraction')
                %set (gca,'XTick',[0 20])

            elseif taushock(ii) == 9
                title(nameshocks(9,:));
                ylabel('Fraction')
                %set (gca,'XTick',[0 20])

            elseif taushock(ii) == 5
                title(nameshocks(5,:));
                ylabel('Fraction')
                %set (gca,'XTick',[0 20])

            else
                title(texlabel(nameshocks(select2,:)));
                ylabel('Fraction')
                %set (gca,'XTick',[0 20])
            end

        else

            subplot(n1,n2,ii)
            plot(date(tt),ssvalues(select2)*exp(psismooth(select1,tt)))
            title(nameshocks(select2,:));
            ylabel('Level')
            %set (gca,'XTick',[0 20])
        end
    end
    %set (gca,'XTick',[0 20])
    axis tight
end

str='Figure 5: Estimated Economic Shocks';
hout=suptitle(str);

%plotsignal.m must be adjusted to reflect that we can have more than one advanced signal
% if max(parstoch(taushock)) > 0
%     figure('name','signals')
%     plotsignal
%     str='Figure : Signals';
%     hout=suptitle(str);
% end

moneyresp=0;
if moneyresp == 1
    if moneyresp ~= 0
        error('fatal (plotpsikal) code is not ready to display the response of policy to the shocks')
    end
    mshocks=zeros(1,length(tt));
    figure
    for ii=1:length(taushock)
        select1=(taushock(ii)-1)*3+3;
        select2=taushock(ii);
        mshocks=mshocks+psismooth(select1,tt);
        subplot(n1,n2,ii)
        if compfilt == 1
            plot(date(tt),400*x*psismooth(select1,tt),'--',date(tt),400*x*psifilt(select1,tt),':')
        else
            plot(date(tt),400*x*psismooth(select1,tt))
        end
        title([texlabel(nameshocks(select2,:)),'(APR)']);
        %set (gca,'XTick',[0 20])
        axis tight    
    end
    %up to now, the convention, xhat(t)=log(x(t)/x) has been used. 
    %this is not convenient for base growth, since is gives rise to a non-linear 
    %relationship among the endogenous components of base growth.
    %so, for base growth we use the convention, xhat(t)=(x(t)-x)/x.
    
    plt=0;
    if plt==0
        subplot(n1,n2,ii+1)
        if compfilt == 1
            plot(date(tt),400*(zz1smooth(23,tt)+1)*x,'--',date(tt),400*(zz1filt(23,tt)+1)*x,':')
            title('Base Growth Rate (APR)')
            axis tight
            hout=suptitle(str);
        else
            plot(date(tt),400*(zz1smooth(23,tt)+1)*x,date(tt),400*basegdatk2(tt),':')
            title('Model Base Growth (Annualized Percent Quarterly Rate)')
            ylabel('base growth in z(t) (-), from p, y, m (..)')
            axis tight
        end
    end
    
    if ii+2 <= n1*n2
        subplot(n1,n2,ii+2)
        plot(date(tt),dbase(tt),date(tt),dbasek2(tt),':')
        title('Base Growth Rate (Annual Average Rate) Model (...)')
        axis tight
    end
    merr=zz1smooth(23,tt)-mshocks;
    if max(abs(merr)) > 6e-5;
        merr
        disp('warning (plotpsikal) base growth incorrectly calculated')
    end
    
    str='Monetary Response to Shocks';
    hout=suptitle(str);
    
end

%
statistics = 0;
if statistics ==1
    shocks_ = psismooth;

    ExtremeCorrBound = 0.2;

    for ii = 2:size(shocks_,2);
        innov(:,ii)=shocks_(:,ii)-Fmle(2*l_z+1:2*l_z+l_psi,2*l_z+1:2*l_z+l_psi)*shocks_(:,ii-1);
    end
    innov(:,1)=shocks_(:,1);

    ii = 0;
    for ij=1:length(taushock)
        ii = ii+1;
        if max(signal_on==taushock(ij))==1
            p=parstoch(taushock(ij));
               
                patriot = innov(IIII(ii),:); 
                signals_t = zeros(p,size(innov,2));
                for jj=p+1:size(innov,2)
                    for iij=p:-1:1
                        signals_t(iij,jj) = innov(IIII(ii+p-iij+1),jj-iij); %1th row there is signal received in previous period about value in current period; in second row signal received 2 periods before about current period; ...in row p there is signal received p periods before about current period
                    end
                end
                
            figure('name',['vintages of information on ',deblank(shockss(taushock(ij),:))])
            subplot(2,1,1)
            plot(date(p+1:end),patriot(p+1:end),'k-',date(p+1:end),sum(signals_t(:,p+1:end),1),'r:')
            legend('time t innovation','sum of advance news received from time t-p to t-1 about shocks in period t')
            axis tight
            title([deblank(shockss(taushock(ij),:))  '. ' 'Current innovation and sum of signals received from t-p and t-1 about value at t. First p periods are removed'])
            subplot(2,1,2)
            plot(date(p+1:end),patriot(p+1:end),'b-',date(p+1:end),sum(signals_t(1:round(size(signals_t,1)/2),p+1:end),1),'r-*',date(p+1:end),sum(signals_t(round(size(signals_t,1)/2)+1:size(signals_t,1),p+1:end),1),'g--')
            
            legend('time t innovation',['sum of signals received from t-1 to t-', num2str(round(p/2)),' about value at t'],['sum of signals received from t-',num2str(round(p/2)+1),' to t-',num2str(p),' about value at t'])
            axis tight
            title([deblank(shockss(taushock(ij),:))  '. ' 'Current innovation, sum of early signals, and sum of later signals'])
            %hout=suptitle(deblank(shockss(taushock(ij),:)));
            
            ii=ii+p;
        end
    end

    
    figure('name','smoothed innovations (1)'); orient landscape
    n1=4;
    n2=4;

    tt_= 2 ; %find(date==1999.0);
    line_vert = date(end); % %last observation before starting the forecast

    for ii=1:min([16 length(IIII)])
        subplot(n1,n2,ii)
        plot(date(tt_:end),innov(IIII(ii),tt_:end),'k-','LineWidth',1)
        axis tight
        line(date(tt_:end),zeros(size(date(tt_:end))),'LineStyle','-','LineWidth', 1,'Color',[0,0,0])

        line('XData',[line_vert+0.12, line_vert+.12],'YData',[min(0,min(innov(IIII(ii),tt_:end))), ...
            max(0,max(innov(IIII(ii),tt_:end)))],'LineStyle','-', 'LineWidth', 3, 'Color',[0.8 0.8 0.8])
        title(deblank(vbname(ii,:)))
        grid on
    end
    hout=suptitle('Smoothed Innovations');
    
    if length(IIII) > 16
        figure('name','smoothed innovations (2)'); orient landscape
        for ii=17:min([32 length(IIII)])
            subplot(n1,n2,ii-16)
            plot(date(tt_:end),innov(IIII(ii),tt_:end),'k-','LineWidth',1)
            axis tight
            line(date(tt_:end),zeros(size(date(tt_:end))),'LineStyle','-','LineWidth', 1,'Color',[0,0,0])

            line('XData',[line_vert+0.12, line_vert+.12],'YData',[min(0,min(innov(IIII(ii),tt_:end))), ...
                max(0,max(innov(IIII(ii),tt_:end)))],'LineStyle','-', 'LineWidth', 3, 'Color',[0.8 0.8 0.8])
            title(deblank(vbname(ii,:)))
            grid on
        end
    end

    tdate = find(date==start_estimation)+init_kalman:find(date==end_estimation);
    for ii=1:length(IIII)
        CorrShocks(ii,ii) = std(innov(IIII(ii),tdate));
        CorrPvalue(ii,ii) = 1;
        [CorrA,Pvalue] = corrcoef(innov(IIII(ii),tdate(2:end)),innov(IIII(ii),tdate(1:end-1)));
        CorrAuto(1:2,ii) = [CorrA(1,2);Pvalue(1,2)];
        MeanShocks(ii) = mean(innov(IIII(ii),tdate));
        if ii<length(IIII)
            for iij = ii+1:length(IIII)
                [CorrS,Pvalue] = corrcoef(innov(IIII(ii),tdate),innov(IIII(iij),tdate));
                CorrShocks(ii,iij) = CorrS(1,2);
                CorrPvalue(ii,iij) = Pvalue(1,2);
            end
        end
    end
    CorrH = triu(CorrShocks,1); 
    
    str_=(['Mean Smoothed Innovations Computed over ' num2str(date(tdate(1))) '-' num2str(date(tdate(end)))]);
    tableMAT(vbname,str_,MeanShocks');
    
    disp(['AUTO-CORRELATION OF SMOOTHED INNOVATIONS Computed over ' num2str(date(tdate(1))) '-' num2str(date(tdate(end)))]);
    disp('Pvalues < 0.05 suggests significant correlation at 95% confidence')
    str_ = char('Autocorr.   ','    Pvalue');
    tableMAT(vbname,str_,CorrAuto');
    
    disp(['CROSS-CORRELATION OF SMOOTHED INNOVATIONS Computed over ' num2str(date(tdate(1))) '-' num2str(date(tdate(end)))]);
    tableMAT(vbname,vbname,(ceil(100*CorrShocks)/100));
    
%     covmat = innov(IIII,tdate)*innov(IIII,tdate)';
%     CorrH = diag(1./sqrt(diag(covmat)))*covmat*diag(1./sqrt(diag(covmat)));
%     CorrH_diag = sqrt(1/size(innov,2)*diag(covmat)); %we normalise by N; alternatively, we could use N-1
%     CorrH = tril(CorrH,-1);
    [RowIndex,ColIndex] = find(abs(CorrH)>ExtremeCorrBound);
    ExtremeCorrParams = cell(length(RowIndex),4);
    for ii=1:length(RowIndex)
        ExtremeCorrParams{ii,1}=deblank(vbname(RowIndex(ii),:));
        ExtremeCorrParams{ii,2}=deblank(vbname(ColIndex(ii),:));
        ExtremeCorrParams{ii,3}=CorrH(RowIndex(ii),ColIndex(ii));
        ExtremeCorrParams{ii,4}=CorrPvalue(RowIndex(ii),ColIndex(ii));
    end
    Index_=[ExtremeCorrParams{:,3}];
    [IInde,Index_] = sort(abs(Index_),2,'descend');
    disp(['Highest Correlation among smoothed innovations, computed over ' num2str(date(tdate(1))) '-' num2str(date(tdate(end)))])
    disp('Pvalues (see last column) < 0.05 suggests significant correlation at 95% confidence')
    ExtremeCorrParams(Index_,:)
    
    if entr==1; subscr='cmr'; elseif entr==2; subscr='nofish'; elseif entr==0; subscr='nobank'; elseif entr==-2; subscr='sw'; elseif entr==-3; subscr='bgg'; elseif entr==-4; subscr='bgg_nofish'; end
    table_residuals(outfolder,vbname,MeanShocks,CorrAuto,CorrShocks,['table_residuals_' subscr '.tex'],entr,cdir)

    %
    psinosmooth = xinosmooth([2*l_z+1:2*l_z+l_psi],:);

    figure; orient landscape
    n1=4;
    n2=4;
    tdate= find(date==start_estimation)+init_kalman:find(date==end_estimation); %find(date==1999.0):find(date==end_estimation)
    line_vert = date(end); %2006.75; %last observation before starting the forecast
    
    disp_mat=[];
    for ii=1:length(III)
        y_innov = psinosmooth(III(ii),tdate(2:end))'; x_innov = [psinosmooth(III(ii),tdate(1:end-1))'];
        bet_ = (x_innov'*x_innov)\(x_innov'*y_innov);
        res_innov = y_innov - x_innov(:,:)*bet_;
        
        disp_mat=[disp_mat; bet_  std(res_innov)  mean(res_innov)];

        subplot(n1,n2,ii)
        plot(date(tdate(2:end)),res_innov,'k-','LineWidth',1)
        axis tight
        line(date(tdate(2:end)),zeros(size(date(tdate(2:end)))),'LineStyle','-','LineWidth', 1,'Color',[0,0,0])

        line('XData',[line_vert+0.12, line_vert+.12],'YData',[min(0,min(res_innov)), ...
            max(0,max(res_innov))],'LineStyle','-', 'LineWidth', 3, 'Color',[0.8 0.8 0.8])
        title(shockss(taushock(ii),:))
        grid on
    end
    
    str_='Fitting a AR(1) Process (using OLS) on one-sided Estimated Economic Shocks.';
    if isempty(signal_on)==0
        str_=[str_ ' Results for Shocks: ' num2str(signal_on) ' should be Ignored as those Shocks Contain a Signal.'];
    end
    hout=suptitle(['Innovations Computed by ' str_]);
    disp([str_ ' Computed over ' num2str(date(tdate(1))) '-' num2str(date(tdate(end)))]);
    tableMAT(shockss(taushock,:),char('rho','std innov.','mean innov.'),disp_mat);
end



%plot fitted variables (XXXsmooth) which were actually used in the estimation (i.e. variables in tauvar) against actual data (XXX)
figure, orient landscape
JXXXsmooth=J*XXXsmooth;
if length(tauvar) < 12
    n1=3;
    n2=4;
elseif length(tauvar) >= 12 && length(tauvar) < 15
    n1=5;
    n2=3;
elseif length(tauvar) >= 15
    n1=4;
    n2=4;
end

l_xxx=size(nameXXX,1);
sX=zeros(l_xxx,1);
sdat=zeros(l_xxx,1);

for ii = 1:l_x
    subplot(n1,n2,ii)
    if fdiff ==1 
        if tauvar(ii) == 1 || tauvar(ii) ==3 || tauvar(ii) ==15 
            plot(date(tt),100*Xdat(ii,tt),'k-',date(tt),100*JXXXsmooth(ii,tt),'r-',date(tt),100*JXXXsmooth(ii,tt),'r.')  
            title(texlabel(nameXXX(tauvar(ii),:)))         
        else 
            plot(date(tt),400*Xdat(ii,tt),'-',date(tt),400*JXXXsmooth(ii,tt),'r-',date(tt),400*JXXXsmooth(ii,tt),'r.')
            title(texlabel(nameXXX(tauvar(ii),:)))
        end
    end
%     if ii < 12
%         set (gca,'XTick',[0 20])
%     end
    axis tight
    sX(ii)=std(Xdat(ii,tt)-JXXXsmooth(ii,tt));
    sdat(ii)=std(Xdat(ii,tt));
    rat(ii)=sX(ii)/sdat(ii);
end

% subplot(n1,n2,ii+1)
% text(.1,.9,'Notes:')
% text(.01,.75,'(i) Model fitted values, produced by')
% text(.01,.60,'    two-sided Kalman smoothing.')
% text(.01,.45,'(ii) Solid line  - Actual data.')
% text(.01,.30,'(iii) In several cases, actual and fitted coincide.')
% set (gca,'XTick',[0 20])
% set (gca,'YTick',[0 1])
% vaxis = axis; %get the current axis value
% xmin = vaxis(1);
% xmax= vaxis(2);
% ymin = vaxis(3);
% ymax = vaxis(4);
% hold on
% plot([xmin xmax],[ymin ymin],'w-') %bottom
% plot([xmin xmin],[ymin ymax],'w-') % left
% %%%%plot([xmin xmax],[ymax ymax],'w-') %top
% plot([xmax xmax],[ymin ymax],'w-') %right

if fdiff ==0
    str='Figure 4: Actual (solid line) and Fitted (dotted line) Data, Growth Rates and Ratios';
elseif fdiff ==1
    str='Figure 4: Actual (solid line) and Fitted (dotted line) Data';
end
hout=suptitle(str);
