function [categ,cmap,signal_on,Corr_sample,Relvar_sample] = shockanalysis(Xdat,F,H,Q,R,initxi,initV,l_z,l_psi,rho,A,B1,J,t1,nameshock,taushock,parstoch, ...
   date,tauvar,is,alf,taum,taub,taus,tausb,mm,trendm3,trendm1,fdiff,plot_levels,outfolder, ...
   entr,start_plot,categ,vert_bar,alpha,b,beta,start_estimation,init_kalman,end_estimation,user,cell_datavintage,show_initialstate)

if plot_levels == 0
    namevbl=strvcat('Log, Net Worth/GDP:','Inflation:','Log, Hours:','Loans:','GDP Growth:','Log, Wage/GDP:','Log, I/GDP:','Log, Vel. M1:','Log, Vel. M3:', ...
    'Log, C/GDP:','Risk Premium:','Spread (10 year):','Ra:','Short Rate:','Log, Capacity Utiliz.:','Log, Government Consumption','Log, Price of Investment (rael)', 'Log, Energy Price (real)', 'Spread (2 year)','Reserves') ;
elseif plot_levels == 1
    namevbl=strvcat('Log, Net Worth:','Log, Price:','Log, Hours:','Log, Credit:','Log, GDP:','Log, Wage:','Log, I:','Log, M1:','Log, M3:', ...
    'Log, C:','Risk Premium:','Spread (10 year):','Ra:','Short Rate:','Log, Capacity Utiliz.:','Log, Government Consumption','Log, Price of Investment (rael)', 'Log, Energy Price (real)', 'Spread (2 year)','Log, Reserves') ;
elseif plot_levels ==2
    namevbl=strvcat('Real Net Worth (yoy)','Inflation (yoy)','Log, Hours','Credit Growth (yoy)','GDP Growth (yoy)','Real Wage Growth (yoy)','Investment Growth (yoy)','M1 Growth (yoy)','M3 Growth (yoy)', ...
    'Consumption Growth (yoy)','Risk Premium','Spread (10 year)','Ra','Short Rate','Log, Capacity Utiliz.','Government Consumption (yoy)','Change in Investment Price (real, yoy)', 'Change in Energy Price (real, yoy)', 'Spread (2 years)','Change in Reserves (yoy)') ;
end

idat = 0; %set =1 when prepare_short below works with the actual data. In that case, we want to do some smoothing on consumption before computing the marginal utility of consumption. Otherwise mu will go negative


%----------------
if user == 1
    [xsmooth, Vsmooth, VVsmooth, loglik] = kalman_smoother(Xdat, F, H, Q, R, initxi, initV);
else
    [xsmooth, Vsmooth, VVsmooth, loglik] = kalman_smoother(Xdat,F,H,Q,R,initxi,initV,alf(tauvar'));
end

l_xxx = size(taum,1);

if length(tauvar) < l_xxx
    if is == 1
        HH    =   [taum,taub,taus,tausb];
    else
        HH    =   [taum,taub,taus];
    end
else
    HH = H;
end

Xt = HH*xsmooth; %the decomposition is computed on demeaned (so we don't add the mean (alf)) fitted (so we do not include m.e.) data

T = size(xsmooth,2);
s = [2*l_z+1:2*l_z+l_psi];

for ii = 2:T
    err(:,ii) = xsmooth(s,ii) - F(s,s)*xsmooth(s,ii-1);
end
err(:,1) = xsmooth(s,1); %this corresponds to assuming that psiinitm1=0, which we do below

zinitm1 = xsmooth(l_z+1:2*l_z,1);
psiinitm1 = zeros(size(xsmooth(2*l_z+1:end,1)));

[XXt,XXXt] = gen(err,zinitm1,psiinitm1,rho,A,B1,taum,taub,taus,T,trendm1,trendm3,mm,fdiff,alpha,b,beta,idat,plot_levels);

eee = max(max(abs(Xt-XXt))); %check to verify that the estimated shocks do drive the smoothed data
if eee > 7e-6
   error('fatal (shockanalysis) check to verify that the estimated shocks do drive the smoothed data has failed')
end

%if t1>1 the decomposition is based on separating out (from a given quarter, called t1, onwards): 
%(a) the unwinding of initial state %and (b) the contribution of new innovations occurring from t1 onwards
%and their unwinding. So the initial state is t1-1
err_t1 = err;
err_t1(:,t1:end) = 0;
[XXt_t1,XXXt_t1] = gen(err_t1,zinitm1,psiinitm1,rho,A,B1,taum,taub,taus,T,trendm1,trendm3,mm,fdiff,alpha,b,beta,idat,plot_levels);

[vbname,signal_on,II,III] = findnum(taushock,parstoch,l_psi,nameshock);

%----do it shock-by-shock
zinitm1_sbs = zeros(size(zinitm1)); %set z(initial_t-1) at non-stochastic steady state

ix=0;
for jj = 1:length(III)
    ii = III(jj);
    ix = ix+1;
    eerp = zeros(l_psi,T);
    
    if max(II==ii) ==1 %recall that shocks (and patriots in case there is a signal structure) come in two pieces to accommodate the AR(2) and lagged shocks on sigma and oil
        eerp(ii:ii+1,1:T) = err(ii:ii+1,1:T);
    else
        eerp(ii,1:T) = err(ii,1:T);
    end

    eerp(:,1:t1-1) = 0;

    [XXtp,XXXtp] = gen(eerp,zinitm1_sbs,psiinitm1,rho,A,B1,taum,taub,taus,T,trendm1,trendm3,mm,fdiff,alpha,b,beta,idat,plot_levels);
    Resp(:,:,ix) = XXXtp;
end

[nvar,T,nshocks] = size(Resp);

tdate = find(date==start_estimation)+init_kalman:find(date==end_estimation); %needed to compute relative variance

if plot_levels == 2
    tdate = tdate(1+4:end); %to accommodate constructing y-o-y terms
end

check = zeros(1,T); %initialise check
check1 =[];
decomp = [];
decomp1 = [];
excel_decomp = [];
ii_var=0;
for ii = 1:nvar
    if max(tauvar==ii)==1
        ii_var = ii_var+1;
        
        var_fitted = var(XXXt(ii,tdate));
        
        for jj = 1:nshocks
            resp = Resp(ii,:,jj);
            
            check = check+resp;
            decomp1 = [decomp1; resp];
            
            if max(resp(tdate))==0
                CorrS(1,2) = 0;
            else
                CorrS = corrcoef(resp(tdate),XXXt(ii,tdate));
            end
            Corr_sample(ii_var,jj) = CorrS(1,2);
            
            Relvar_sample(ii_var,jj) = var(resp(tdate))/var_fitted;
            
        end
        decomp = [decomp; decomp1];
        %if ii==9; keyboard; end
        excel_decomp = [excel_decomp XXXt(ii,find(date==1988.0):end)' decomp1(:,find(date==1988.0):end)' repmat(9999,size(XXXt(:,find(date==1988.0):end),2),1)];
        decomp1 = [];
        check1 = [check1; check];
        check = zeros(1,T); %reset check to zero
    end
end    

if entr ~= 1
    contrib_stock = [];
end

save([outfolder '\excel_contrib'], 'excel_decomp', '-ASCII')


n1 = 5; 
n2 = 5;
if start_plot < 1 + init_kalman + 4
    start_plot = start_plot + min(4+init_kalman,1+init_kalman+4-start_plot); %first 4 quarters get lost in creating levels or yoy out of growth rates 
end
tt = start_plot:T; %this is for the plot

check_plot = zeros(1,T);

show_signals = 1; %=1 show contribution of each individual signals; =0, show impact of all signals (plus patriot) together

for jj=1:length(tauvar)
    str1=[deblank(namevbl(tauvar(jj),:)), '. Historical decomposition.'];
    h = figure('name',str1); orient landscape
    if show_signals==1
       hh = figure('name',[str1 'Signals.']); orient landscape;
       ia = 0;
    end

    decomp_singlevb = decomp(nshocks*(jj-1)+1:nshocks*jj,:);
    
    ii = 0;
    for ij=1:length(taushock)
        ii = ii+1;
        decomp_singlevb_single_shk = decomp_singlevb(ii,:);

        if max(signal_on==taushock(ij))==1
            patriot=decomp_singlevb_single_shk;
            earlier=zeros(1,length(decomp_singlevb(ii,:)));

            p=parstoch(taushock(ij));
            if p == 1
                error('fatal (shockanalysis) graphics cannot handle the case one lagged signal')
            end
            p2=round(p/2);
            for ss = p:-1:1
                decomp_singlevb_single_shk=decomp_singlevb_single_shk+ decomp_singlevb(ii+ss,:);
                earlier=earlier+decomp_singlevb(ii+ss,:);
                if ss == p2+1;
                    recent=decomp_singlevb_single_shk;
                    recentsignals=recent-patriot;
                    earlier=zeros(1,length(decomp_singlevb(ii,:)));
                end
            end
            ii=ii+parstoch(taushock(ij));
            
            if show_signals==1
                figure(hh)
                ia = ia+1;
                subplot(5,4,ia)
                plot(date(tt),XXXt(tauvar(jj),tt),'k-',date(tt),earlier(tt),'r.-')
                ss=[nameshock(taushock(ij),:), ' earlier signals ',num2str(p2+1),' to ',num2str(p)];
                title(ss)
                axis tight
                ia= ia+1;
                subplot(5,4,ia)
                plot(date(tt),XXXt(tauvar(jj),tt),'k-',date(tt),recent(tt),'r.-')
                ss=[nameshock(taushock(ij),:), ' recent signals, contemporaneous to ',num2str(p2)];
                title(ss)
                axis tight
                ia= ia+1;
                subplot(5,4,ia)
                plot(date(tt),XXXt(tauvar(jj),tt),'k-',date(tt),recentsignals(tt),'r.-')
                ss=[nameshock(taushock(ij),:), ' recent signals, ',num2str(1),' to ',num2str(p2)];
                title(ss)
                axis tight
                ia= ia+1;
                subplot(5,4,ia)
                plot(date(tt),XXXt(tauvar(jj),tt),'k-',date(tt),patriot(tt),'r.-')
                ss=[nameshock(taushock(ij),:), ' contemporaneous shock only'];
                title(ss)
                axis tight
            end
        end
        figure(h)
        subplot(n1,n2,ij)
        plot(date(tt),XXXt(tauvar(jj),tt),'k-',date(tt),decomp_singlevb_single_shk(tt),'r.-')
        
%         figure %to be used when you want left and right axes to be different
%         [AX,H1,H2] = plotyy(date(tt),XXXt(tauvar(jj),tt),date(tt),decomp_singlevb_single_shk(tt),'plot')
%         set(AX(1),'YColor',[0 0 0])
%         set(AX(2),'YColor',[0 0 0])
%         set(AX(1),'Ylim',[min(XXXt(tauvar(jj),tt)) max(XXXt(tauvar(jj),tt))])
%         set(AX(2),'Ylim',[min(decomp_singlevb_single_shk(tt)) max(decomp_singlevb_single_shk(tt))])
%         set(AX(1),'YTick',[min(XXXt(tauvar(jj),tt)):std(XXXt(tauvar(jj),tt)): max(XXXt(tauvar(jj),tt))])
%         set(AX(2),'YTick',[min(decomp_singlevb_single_shk(tt)):std(decomp_singlevb_single_shk(tt))/2: max(decomp_singlevb_single_shk(tt))])
% 
%         set(AX(1),'TickDir','out')
%         set(AX(2),'TickDir','out')
% 
%         set(H1,'linewidth',1,'Color',[0,0,0],'Linestyle','-')
%         set(H2,'linewidth',1,'Color',[1,0,0],'Linestyle','-')
%         xlim([date(tt(1)) date(tt(end))])
       
        title(nameshock(taushock(ij),:))
        axis tight

        check_plot = check_plot + decomp_singlevb_single_shk;

        if max(tauvar(jj)==1)==1 %stock market
            if strncmp(nameshock(taushock(ij),:),'\gamma_{t}',10)==1
                contrib_stock.name = '\gamma_{t}';
                contrib_stock.fitted = XXXt(tauvar(jj),tt);
                contrib_stock.date   = date(tt);
                contrib_stock.value = decomp_singlevb_single_shk(tt);
            elseif strncmp(nameshock(taushock(ij),:),'Mon. Pol.',9)==1
                contrib_stock(2).name = 'Monetary Policy shock';
                contrib_stock(2).value = decomp_singlevb_single_shk(tt);
            elseif strncmp(nameshock(taushock(ij),:),'\sigma_{t}',10)==1
                contrib_stock(3).name = '\sigma_{t}';
                contrib_stock(3).value = decomp_singlevb_single_shk(tt);
            elseif strncmp(nameshock(taushock(ij),:),'\zeta_{i,t}',11)==1
                contrib_stock(4).name = '\zeta_{i,t}';
                contrib_stock(4).value = decomp_singlevb_single_shk(tt);
            elseif strncmp(nameshock(taushock(ij),:),'\tau^{oil}_{t}',14)==1
                contrib_stock(5).name = 'energy, \tau^{oil}_{t}';
                contrib_stock(5).value = decomp_singlevb_single_shk(tt);
            end
        elseif max(tauvar(jj)==2)==1 %inflation
            if strncmp(nameshock(taushock(ij),:),'\lambda_{f,t}',12)==1
                contrib_infl.name = 'firm markup, \lambda_{f,t}';
                contrib_infl.fitted = XXXt(tauvar(jj),tt);
                contrib_infl.date   = date(tt);
                contrib_infl.value = decomp_singlevb_single_shk(tt);
            elseif strncmp(nameshock(taushock(ij),:),'\pi^{*}_{t}',11)==1
                contrib_infl(2).name = 'Inflation objective';
                contrib_infl(2).value = decomp_singlevb_single_shk(tt);
            elseif strncmp(nameshock(taushock(ij),:),'\zeta_{c,t}',11)==1
                contrib_infl(3).name = '\zeta_{c,t}';
                contrib_infl(3).value = decomp_singlevb_single_shk(tt);
            elseif strncmp(nameshock(taushock(ij),:),'\zeta_{i,t}',11)==1
                contrib_infl(4).name = '\zeta_{i,t}';
                contrib_infl(4).value = decomp_singlevb_single_shk(tt);
            elseif strncmp(nameshock(taushock(ij),:),'\tau^{oil}_{t}',14)==1
                contrib_infl(5).name = 'energy, \tau^{oil}_{t}';
                contrib_infl(5).value = decomp_singlevb_single_shk(tt);
            end
        elseif max(tauvar(jj)==5)==1 %gdp
            if strncmp(nameshock(taushock(ij),:),'\gamma_{t}',10)==1
                contrib_gdp.name = '\gamma_{t}';
                contrib_gdp.fitted = XXXt(tauvar(jj),tt);
                contrib_gdp.date   = date(tt);
                contrib_gdp.value = decomp_singlevb_single_shk(tt);
            elseif strncmp(nameshock(taushock(ij),:),'Mon. Pol.',9)==1
                contrib_gdp(2).name = 'Monetary Policy shock';
                contrib_gdp(2).value = decomp_singlevb_single_shk(tt);
            elseif strncmp(nameshock(taushock(ij),:),'\zeta_{c,t}',11)==1
                contrib_gdp(3).name = '\zeta_{c,t}';
                contrib_gdp(3).value = decomp_singlevb_single_shk(tt);
            elseif strncmp(nameshock(taushock(ij),:),'\zeta_{i,t}',11)==1
                contrib_gdp(4).name = '\zeta_{i,t}';
                contrib_gdp(4).value = decomp_singlevb_single_shk(tt);
            elseif strncmp(nameshock(taushock(ij),:),'\tau^{oil}_{t}',14)==1
                contrib_gdp(5).name = 'energy, \tau^{oil}_{t}';
                contrib_gdp(5).value = decomp_singlevb_single_shk(tt);
            end
        end
    end

    if max(check_plot - check1(jj,:)) > 1e-10
        error('fatal (shockanalysis) there is a mistake in plotting shocks contribution')
    end
    check_plot = zeros(1,T);
    
    if max(check1(jj,:)+XXXt_t1(tauvar(jj),:)-XXXt(tauvar(jj),:)) > 1e-10
        %error('fatal (shockanalysis) there is a mistake in computing shock contribution')
    end

    subplot(n1,n2,ij+1);plot(date(tt),XXXt(tauvar(jj),tt),'k-',date(tt),XXXt_t1(tauvar(jj),tt),'g.-'); title('Initial state');axis tight
    
    subplot(n1,n2,ij+2);plot(date(tt),XXXt(tauvar(jj),tt),'k-',date(tt),check1(jj,tt),'b.-'); title('do match? Excluding initial state');axis tight
    str=[deblank(namevbl(tauvar(jj),:)), ' Smoothed Data (-) and Data Driven by just a Given Shock, including its signal (*)'];
    figure(h); hout=suptitle(str);
    if show_signals==1
        figure(hh); hout=suptitle(str);
    end
end

save([outfolder '\contributions'], 'contrib_stock', 'contrib_infl', 'contrib_gdp');

%construct the categories of shocks
[decomp_new,categ,cmap,lgx_] = make_categ(decomp,tauvar,taushock,categ,signal_on,parstoch);

%plot bar chart
if show_initialstate ==1  %add initial state as an additional category   
    XXXt_t1 = XXXt_t1(tauvar,:)';
    ncat      = size(lgx_,1);
    decomp_new_e = [];
    for kk = 1:size(XXXt_t1,2);
        decomp_new_e = [decomp_new_e, decomp_new(:,ncat*(kk-1)+[1:ncat]), XXXt_t1(:,kk)];
    end
    lgx_ = [lgx_; 'Initial State'];
    cmap = [cmap; [0 0 0] ];

    check1 = XXXt(tauvar,:);
    decomp_new = decomp_new_e;
end

str = [];
plot_contributions(decomp_new,date,start_plot,tauvar,XXXt(tauvar,:),namevbl(tauvar,:),check1,vert_bar,cmap,lgx_,str)


