function [q,u,pii,RT,Re,Rk,omegabar,Fomegabar,Gamma,G,n,k,i, ...
    w,l,y,phi,g,c,vn,uzc,lamz,Ra,her,Rm,dm,mb,m,erz,ev,hkb,vl,costs,R] = steadyexog(parameters)

entr      = parameters(1);
pref      = parameters(2);
lambdaw   = parameters(3);
sigmaL    = parameters(4);
theta     = parameters(5);
v         = parameters(6);
beta      = parameters(7);
xiw       = parameters(8);
Hdoupr    = parameters(9);
sigmaq    = parameters(10);
b         = parameters(11);
psiL      = parameters(12);
m         = parameters(13);
chii      = parameters(14);
duration  = parameters(15);
zetac     = parameters(16);
iotaw1    = parameters(17);
iotaw2    = parameters(18);
iotamu    = parameters(19);
Fomegabar = parameters(20);
sigma     = parameters(21);
mu        = parameters(22);
gamma     = parameters(23);
we        = parameters(24);
bigtheta  = parameters(25);
sigmaa    = parameters(26);
Sdoupr    = parameters(27);
etai      = parameters(28);
muup      = parameters(29);
zeta      = parameters(30);
muzstar   = parameters(31);
upsil     = parameters(32);
lambdaf   = parameters(33);
alpha     = parameters(34);
psik      = parameters(35);
psil      = parameters(36);
delta     = parameters(37);
epsil     = parameters(38);
xip       = parameters(39);
iota1     = parameters(40);
iota2     = parameters(41);
ksi       = parameters(42);
xb        = parameters(43);
chorse    = parameters(44);
rhobank   = parameters(45);
vl        = parameters(46);
vk        = parameters(47);
etag      = parameters(48);
tauk      = parameters(49);
taul      = parameters(50);
tauc      = parameters(51);
tauD      = parameters(52);
tauT      = parameters(53);
tau       = parameters(54);
x         = parameters(55);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
q       =   1;
u       =   1;
pii      =   (1+x)/muzstar;
RT      =   ((muzstar*pii/beta)-1)/(1-tauD);
Re      =   RT;

xxin(1)   = log(0.69); % m initial values
xxin(2)   = log(1.28542605069285); % her
xxin(3)   = log(0.72488515509788); % c
xxin(4)   = -log((1-0.47633752437817)/0.47633752437817); %omegabar

opt=optimset('display','iter','diagnostics','on','LevenbergMarquardt','on','TolX',1e-21,'TolFun',1e-21,'MaxIter',10000,'MaxFunEvals',10000);
[xxout,fval,exitflag,output] =  fsolve(@ssteadyexog,xxin,opt,x,theta,Re,alpha,ksi,xb,tau,lambdaf, ...
    chorse,chii,tauD,muzstar,beta,pii,sigma,mu,tauk, ...
    delta,upsil,we,gamma,psik,psil,lambdaw,zeta,psiL,sigmaL,taul,tauc,sigmaq,b,v,etag,bigtheta,pref);

if abs(fval ) > .1e-9 | abs(imag(m))>.1e-10 | exitflag <= 0
    error('fatal (steadyexog) failed to find m')
end


[ff,Ra,R,ev,Rm,dm,mb,lamz,Fomegabar,Gamma,G,Rk,rk,n,k,w,l,i,y,vk,costs,erz] = ssteadyexog(xxout,x, ...
    theta,Re,alpha,ksi,xb,tau,lambdaf,chorse,chii,tauD,muzstar,beta,pii,sigma,mu,tauk, ...
    delta,upsil,we,gamma,psik,psil,lambdaw,zeta,psiL,sigmaL,taul,tauc,sigmaq,b,v,etag,bigtheta,pref);

m = (exp(xxout(1)));
her = (exp(xxout(2)));
c = (exp(xxout(3)));
omegabar = (1/(1+exp(-xxout(4))));

hkb = alpha*ksi*xb*ev^(1-ksi)*lambdaf*rk*(1+psik*R)/alpha;
vl = vk;
g = etag*y;
phi =  vk*((k/(muzstar*upsil))^alpha)*(l^(1-alpha))*(1-1/lambdaf);
uzc = (muzstar-b*beta)/(c*(muzstar-b));
vn = (n-we)/gamma;

