function  micro(sigma_SS,omegabar,Rk,Re,k,n,Pe_SS,mu)

ick=0;%controls whether it is sigma (ick=0) or sp1 (ick=1) that is perturbed

%sp1 and sig are exogenous in these calculations
sp1=(1+Rk)/(1+Re);
sig=sigma_SS;

lev_SS=k/n;
Pe_SS=sp1*omegabar*lev_SS/(lev_SS-1);

%take sp1 and sig as given and find Pe and lev that solve the CSV
%contracting problem

%step 1: find omega that solves the first order condition
[ff,G,F,Gamma,Gam_muG,Fprime]=findomeg(omegabar,sig,mu,sp1);
if abs(ff) > .1e-10
    error('fatal(micro) omegabar not a steady state')
end
%step 2: leverage and spread
lev=1/(1-Gam_muG*sp1);
Pe=sp1*omegabar*lev/(lev-1);
if abs(lev - lev_SS) > .1e-10 | abs(Pe-Pe_SS) > .1e-10
    error('fatal (micro) not a steady state')
end

%get the level of utility at the steady state equilibrium:
Ubar=(1-Gamma)*sp1*lev;

%display the level of entrepreneurial utility as a function of leverage
lever=[];
util=[];
utilp=[]
lever=1.001:.0001:1.1;
for ii = 1:length(lever)
    leve=lever(ii);
    [ff,omega,z,G,F,Gamma,er] = leverage(Pe,leve,sp1,sig,Ubar);
    util(ii)=(1-Gamma)*sp1*leve;
    [ff,omega,z,G,F,Gamma,er] = leverage(Pe,leve,sp1,sig*1.02,Ubar);
    utilp(ii)=(1-Gamma)*sp1*leve;
end
plot(lever,util,lever,utilp,'*-')
legend('baseline','perturbed')
ylabel('objective')
xlabel('leverage')
axis tight

llev=1.001:.01:1.2;
PPe=1.001:.001:Pe*(1+.2);
[indPe] = indifference(llev,PPe,sp1,sig,Ubar);
[profPe] = zprofits(llev,PPe,sp1,sig,mu);
Iind=find(indPe>.0001);
Iprof=find(profPe>.0001);


%now go for the pertubed equilibrium

if ick==0 
    llevt=llev;
    ip=1.05;
    ss=['Effect of a ',num2str(100*(ip-1)),'% jump in \sigma'];
    [omega,er] = ffindomeg(sig*ip,mu,sp1);
end
if ick==1;
    llevt=1.17:.01:1.25;
    ip=1.02;
    ss=['effect of a ',num2str(100*(ip-1)),'% jump in s'''];
    sp1=sp1*ip;
    ip=1;
    [omega,er] = ffindomeg(sig,mu,sp1);
end

if er == 1
    error('fatal (micro) failed to find omega')
end
[ff,G,F,Gamma,Gam_muG,Fprime]=findomeg(omega,sig*ip,mu,sp1);
if abs(ff) > .1e-10
    error('fatal (micro) mistake')
end
lev=1/(1-Gam_muG*sp1);
Pe=sp1*omega*lev/(lev-1);
Ubart=(1-Gamma)*sp1*lev;

[indPet] = indifference(llevt,PPe,sp1,sig*ip,Ubart);
[profPet] = zprofits(llevt,PPe,sp1,sig*ip,mu);
Iindt=find(indPet>.0001);
Iproft=find(profPet>.0001);

plot(llev(Iind),400*(indPe(Iind)-1),llev(Iprof),400*(profPe(Iprof)-1),llevt(Iindt),400*(indPet(Iindt)-1),llevt(Iproft),400*(profPet(Iproft)-1),lev_SS,400*(Pe_SS-1),'*',lev,400*(Pe-1),'*')
xlabel('leverage, qK/N','fontsize',28)
ylabel('risk spread (APR)','fontsize',20)
title(ss,'fontsize',36)
%axis([1.1 1.14 1.5 4])
axis tight
disp('hi')

